// FeliX-Datei 
Config:=[xc["B"] = -4.094202899, yc["B"] = -5.235507246, ac["L"] = -0.1905239167, bc["L"] = 0.9816825542, cc["L"] = -4.359562553, ac["L5"] = -0.9297006918, bc["L5"] = 0.3683159291, cc["L5"] = 1.878062552, xc["N"] = 1.928919856, yc["N"] = 1.554442565, xc["X"] = 4.608007225, yc["X"] = 2.455415112, xc["A"] = 0.3985507246, yc["A"] = 6.105072464, ac["L9"] = 0.947836833, bc["L9"] = 0.3187559224, cc["L9"] = 2.323789061, xc["C"] = 3.703429336, yc["C"] = -3.72215099, xc["P"] = -0.2801373337, yc["P"] = 4.391932446, ac["L12"] = 0.3683159291, bc["L12"] = 0.9297006918, cc["L12"] = 3.980003591, ac["L13"] = -0.9816825542, bc["L13"] = -0.1905239167, cc["L13"] = -4.991415607, xc["M"] = 5.730586555, yc["M"] = -3.328722451, ac["L15"] = 0.3187559224, bc["L15"] = -0.947836833, cc["L15"] = -0.8585032905];
Objects:=[["B", "point"], ["L", "line"], ["L5", "line"], ["N", "point"], ["X", "point"], ["A", "point"], ["L9", "line"], ["C", "point"], ["P", "point"], ["L12", "line"], ["L13", "line"], ["M", "point"], ["L15", "line"]];
BasicObjects:=["B", "CC", "PP", "C", "A"];
Equations:=[ac["L"]*xc["B"] + bc["L"]*yc["B"] = cc["L"], ac["L5"]*xc["B"] + bc["L5"]*yc["B"] = cc["L5"], ac["L5"]*xc["A"] + bc["L5"]*yc["A"] = cc["L5"], ac["L9"]*xc["A"] + bc["L9"]*yc["A"] = cc["L9"], ac["L9"]*xc["N"] + bc["L9"]*yc["N"] = cc["L9"], ac["L9"]*xc["C"] + bc["L9"]*yc["C"] = cc["L9"], ac["L"]*xc["C"] + bc["L"]*yc["C"] = cc["L"], ac["L5"]*xc["P"] + bc["L5"]*yc["P"] = cc["L5"], ac["L12"]*ac["L5"] + bc["L12"]*bc["L5"] = 0, ac["L12"]*xc["P"] + bc["L12"]*yc["P"] = cc["L12"], ac["L"]*ac["L13"] + bc["L"]*bc["L13"] = 0, ac["L13"]*xc["X"] + bc["L13"]*yc["X"] = cc["L13"], ac["L12"]*xc["X"] + bc["L12"]*yc["X"] = cc["L12"], ac["L"]*xc["M"] + bc["L"]*yc["M"] = cc["L"], ac["L13"]*xc["M"] + bc["L13"]*yc["M"] = cc["L13"], ac["L15"]*xc["X"] + bc["L15"]*yc["X"] = cc["L15"], ac["L15"]*xc["N"] + bc["L15"]*yc["N"] = cc["L15"], ac["L15"]*ac["L9"] + bc["L15"]*bc["L9"] = 0, xc["M"]*yc["N"] - xc["N"]*yc["M"] - xc["M"]*yc["P"] + yc["M"]*xc["P"] + xc["N"]*yc["P"] - yc["N"]*xc["P"] = 0];
FelixCurves:=[];
FXcomments:=[];
commentTable:=table(ac["L5"]*xc["B"] + bc["L5"]*yc["B"] = cc["L5"]="B auf L5",ac["L9"]*xc["C"] + bc["L9"]*yc["C"] = cc["L9"]="C auf L9",ac["L13"]*xc["M"] + bc["L13"]*yc["M"] = cc["L13"]="M auf L13",ac["L9"]*xc["N"] + bc["L9"]*yc["N"] = cc["L9"]="N auf L9",ac["L9"]*xc["A"] + bc["L9"]*yc["A"] = cc["L9"]="A auf L9",ac["L13"]*xc["X"] + bc["L13"]*yc["X"] = cc["L13"]="X auf L13",xc["CCCC"]*ac["L"] + yc["CCCC"]*bc["L"] = cc["L"]="CC auf L",ac["L15"]*xc["N"] + bc["L15"]*yc["N"] = cc["L15"]="N auf L15",ac["L12"]*xc["X"] + bc["L12"]*yc["X"] = cc["L12"]="X auf L12",ac["L"]*xc["B"] + bc["L"]*yc["B"] = cc["L"]="B auf L",xc["PPPPPP"]*ac["L5"] + yc["PPPPPP"]*bc["L5"] = cc["L5"]="PP auf L5",ac["L5"]*xc["P"] + bc["L5"]*yc["P"] = cc["L5"]="P auf L5",ac["L"]*xc["M"] + bc["L"]*yc["M"] = cc["L"]="M auf L",ac["L5"]*xc["A"] + bc["L5"]*yc["A"] = cc["L5"]="A auf L5",ac["L12"]*ac["L5"] + bc["L12"]*bc["L5"] = 0="L12 ortho L5",ac["L12"]*xc["P"] + bc["L12"]*yc["P"] = cc["L12"]="P auf L12",ac["L15"]*ac["L9"] + bc["L15"]*bc["L9"] = 0="L15 ortho L9",ac["L"]*ac["L13"] + bc["L"]*bc["L13"] = 0="L13 ortho L",ac["L"]*xc["C"] + bc["L"]*yc["C"] = cc["L"]="C auf L",ac["L15"]*xc["X"] + bc["L15"]*yc["X"] = cc["L15"]="X auf L15");
FXConOpt:=[];
FXCanvasOpt:=[];
NameCounter:=16;
FXuseLP:=TRUE;
FXuseSPH:=FALSE;
FXRandomR:=0.0;
FXText:="";
VisualProps:="A:TRUE:TRUE:255,0,0,255;B:TRUE:TRUE:255,0,0,255;C:TRUE:TRUE:255,0,0,255;L:TRUE:TRUE:255,0,0,255;L12:TRUE:TRUE:255,0,0,255;L13:TRUE:TRUE:255,0,0,255;L15:TRUE:TRUE:255,0,0,255;L5:TRUE:TRUE:255,0,0,255;L9:TRUE:TRUE:255,0,0,255;M:TRUE:TRUE:255,0,0,255;N:TRUE:TRUE:255,0,0,255;P:TRUE:TRUE:255,0,0,255;X:TRUE:TRUE:255,0,0,255";

