// FeliX-Datei 
Config:=[xc["P1"] = -3.913043478, yc["P1"] = 0.3804347826, xc["P2"] = 3.804347826, yc["P2"] = 0.5615942029, ac["L3"] = -0.02346771351, bc["L3"] = 0.9997245953, cc["L3"] = 0.4721601923, xc["P4"] = 5.79710145, yc["P4"] = 4.583333333, ac["L5"] = -0.02346771351, bc["L5"] = 0.9997245953, cc["L5"] = 4.446026345, xc["P6"] = -2.441090615, yc["P6"] = 4.389948543, xc["S7"] = -2.441090615, yc["S7"] = 4.389948543, vx["S7"] = 6.245438441, vy["S7"] = -3.82835434, xc["S8"] = -2.441090615, yc["S8"] = 4.389948543, vx["S8"] = -1.471952864, vy["S8"] = -4.00951376, ac["L9"] = -0.9997245953, bc["L9"] = -0.02346771351, cc["L9"] = 2.337396272, ac["L10"] = -0.3446256584, bc["L10"] = -0.938740196, cc["L10"] = -1.838266926, xc["P11"] = -2.404731274, yc["P11"] = 2.841040616];
Objects:=[["P1", "point"], ["P2", "point"], ["L3", "line"], ["P4", "point"], ["L5", "line"], ["P6", "point"], ["S7", "vector"], ["S8", "vector"], ["L9", "line"], ["L10", "line"], ["P11", "point"]];
BasicObjects:=["P4", "P1", "P2"];
Equations:=[ac["L3"]*xc["P1"] + bc["L3"]*yc["P1"] = cc["L3"], ac["L3"]*xc["P2"] + bc["L3"]*yc["P2"] = cc["L3"], ac["L5"]*bc["L3"] - ac["L3"]*bc["L5"] = 0, ac["L5"]*xc["P4"] + bc["L5"]*yc["P4"] = cc["L5"], ac["L5"]*xc["P6"] + bc["L5"]*yc["P6"] = cc["L5"], xc["S7"] = xc["P6"], yc["S7"] = yc["P6"], vx["S7"] = xc["P2"] - xc["P6"], vy["S7"] = yc["P2"] - yc["P6"], xc["S8"] = xc["P6"], yc["S8"] = yc["P6"], vx["S8"] = xc["P1"] - xc["P6"], vy["S8"] = yc["P1"] - yc["P6"], ac["L3"]*ac["L9"] + bc["L3"]*bc["L9"] = 0, ac["L9"]*xc["P6"] + bc["L9"]*yc["P6"] = cc["L9"], bc["L10"]*vx["S8"] - ac["L10"]*vy["S8"] = 0, ac["L10"]*xc["P2"] + bc["L10"]*yc["P2"] = cc["L10"], ac["L10"]*xc["P11"] + bc["L10"]*yc["P11"] = cc["L10"], ac["L9"]*xc["P11"] + bc["L9"]*yc["P11"] = cc["L9"]];
FelixCurves:=[];
FXcomments:=[];
commentTable:=table(ac["L10"]*xc["P11"] + bc["L10"]*yc["P11"] = cc["L10"]="P11 auf L10",ac["L5"]*xc["P4"] + bc["L5"]*yc["P4"] = cc["L5"]="P4 auf L5",ac["L9"]*xc["P11"] + bc["L9"]*yc["P11"] = cc["L9"]="P11 auf L9",ac["L5"]*bc["L3"] - ac["L3"]*bc["L5"] = 0="L5 parallel L3",ac["L5"]*xc["P6"] + bc["L5"]*yc["P6"] = cc["L5"]="P6 auf L5",yc["S7"] = yc["P6"]="y Anfang S7 = P6",vx["S8"] = xc["P1"] - xc["P6"]="x Ende S8 = P1",vx["S7"] = xc["P2"] - xc["P6"]="x Ende S7 = P2",yc["S8"] = yc["P6"]="y Anfang S8 = P6",ac["L10"]*xc["P2"] + bc["L10"]*yc["P2"] = cc["L10"]="P2 auf L10",ac["L3"]*xc["P1"] + bc["L3"]*yc["P1"] = cc["L3"]="P1 auf L3",ac["L3"]*xc["P2"] + bc["L3"]*yc["P2"] = cc["L3"]="P2 auf L3",bc["L10"]*vx["S8"] - ac["L10"]*vy["S8"] = 0="L10 ortho S8",ac["L3"]*ac["L9"] + bc["L3"]*bc["L9"] = 0="L9 ortho L3",vy["S8"] = yc["P1"] - yc["P6"]="y Ende S8 = P1",vy["S7"] = yc["P2"] - yc["P6"]="y Ende S7 = P2",xc["S7"] = xc["P6"]="x Anfang S7 = P6",xc["S8"] = xc["P6"]="x Anfang S8 = P6",ac["L9"]*xc["P6"] + bc["L9"]*yc["P6"] = cc["L9"]="P6 auf L9");
FXConOpt:=[];
FXCanvasOpt:=[[238, 238, 238], [150, 150, 150], [50, 50, 50], TRUE];
NameCounter:=12;
FXuseLP:=TRUE;
FXuseSPH:=FALSE;
FXRandomR:=0.0;
VisualProps:="L10:TRUE:TRUE:51,255,51,255;L3:TRUE:TRUE:255,0,0,255;L5:TRUE:TRUE:255,0,0,255;L9:TRUE:TRUE:51,255,51,255;P1:TRUE:TRUE:255,0,0,255;P11:TRUE:TRUE:255,255,51,255;P2:TRUE:TRUE:255,0,0,255;P4:TRUE:TRUE:255,0,0,255;P6:TRUE:TRUE:255,0,0,255;S7:TRUE:TRUE:255,0,0,255;S8:TRUE:TRUE:255,0,0,255";

