// FeliX-Datei 
Config:=[xc["P1"] = -8.371122874, yc["P1"] = 0.2783465168, xc["P2"] = 0.5058167049, yc["P2"] = -4.325993144, xc["P3"] = 4.189288434, yc["P3"] = 2.775558519, xc["P4"] = -4.687651145, yc["P4"] = 7.37989818, xc["S5"] = -8.371122874, yc["S5"] = 0.2783465168, vx["S5"] = 8.876939579, vy["S5"] = -4.604339661, xc["S6"] = 0.5058167049, yc["S6"] = -4.325993144, vx["S6"] = 3.683471729, vy["S6"] = 7.101551663, xc["S7"] = 4.189288434, yc["S7"] = 2.775558519, vx["S7"] = -8.876939579, vy["S7"] = 4.604339661, xc["S8"] = -4.687651145, yc["S8"] = 7.37989818, vx["S8"] = -3.683471729, vy["S8"] = -7.101551663, xc["A1"] = -4.710144928, yc["A1"] = -2.300724638, xc["A2"] = 3.043478261, yc["A2"] = -1.539855072];
Objects:=[["P1", "point"], ["P2", "point"], ["P3", "point"], ["P4", "point"], ["S5", "vector"], ["S6", "vector"], ["S7", "vector"], ["S8", "vector"], ["A1", "point"], ["A2", "point"]];
BasicObjects:=["A1", "A2", "P11"];
Equations:=[xc["S5"] = xc["P1"], yc["S5"] = yc["P1"], vx["S5"] = xc["P2"] - xc["P1"], vy["S5"] = yc["P2"] - yc["P1"], xc["S6"] = xc["P2"], yc["S6"] = yc["P2"], vx["S6"] = xc["P3"] - xc["P2"], vy["S6"] = yc["P3"] - yc["P2"], xc["S7"] = xc["P3"], yc["S7"] = yc["P3"], vx["S7"] = xc["P4"] - xc["P3"], vy["S7"] = yc["P4"] - yc["P3"], xc["S8"] = xc["P4"], yc["S8"] = yc["P4"], vx["S8"] = xc["P1"] - xc["P4"], vy["S8"] = yc["P1"] - yc["P4"], - vx["S5"]*vx["S8"] - vy["S5"]*vy["S8"] = 0, - vx["S7"]*vx["S8"] - vy["S7"]*vy["S8"] = 0, - vx["S6"]*vx["S7"] - vy["S6"]*vy["S7"] = 0, vx["S5"]^2 + vy["S5"]^2 = 100, vx["S8"]^2 + vy["S8"]^2 = 64, yc["A2"]*vx["S6"] - xc["A2"]*vy["S6"] < vx["S6"]*yc["S6"] - vy["S6"]*xc["S6"], yc["A1"]*vx["S5"] - xc["A1"]*vy["S5"] < vx["S5"]*yc["S5"] - vy["S5"]*xc["S5"]];
FelixCurves:=[];
FXcomments:=[];
commentTable:=table((vy["S8"] = yc["P1"] - yc["P4"])="y Ende S8 = P1",(vx["S5"] = xc["P2"] - xc["P1"])="x Ende S5 = P2",(vx["S8"]^2 + vy["S8"]^2 = 36.0)="S8 Laenge=6.0",(yc["S5"] = yc["P1"])="y Anfang S5 = P1",(yc["A1"]*vx["S5"] - xc["A1"]*vy["S5"] = vx["S5"]*yc["S5"] - vy["S5"]*xc["S5"])="A1 auf S5",(0 < (xc["A1"] - xc["S5"])*vx["S5"] + (yc["A1"] - yc["S5"])*vy["S5"])="A1 innerhalb trager",(yc["S7"] = yc["P3"])="y Anfang S7 = P3",(xc["S6"] = xc["P2"])="x Anfang S6 = P2",(xc["S8"] = xc["P4"])="x Anfang S8 = P4",(vy["S5"] = yc["P2"] - yc["P1"])="y Ende S5 = P2",(yc["A2"]*vx["S6"] - xc["A2"]*vy["S6"] = vx["S6"]*yc["S6"] - vy["S6"]*xc["S6"])="A2 auf S6",(vx["S6"] = xc["P3"] - xc["P2"])="x Ende S6 = P3",(vy["S6"] = yc["P3"] - yc["P2"])="y Ende S6 = P3",(vx["S7"] = xc["P4"] - xc["P3"])="x Ende S7 = P4",(yc["S6"] = yc["P2"])="y Anfang S6 = P2",(- vx["S5"]*(vx["S5"] - xc["A1"] + xc["S5"]) - vy["S5"]*(vy["S5"] - yc["A1"] + yc["S5"]) < 0)="A1 innerhalb trager",(yc["S8"] = yc["P4"])="y Anfang S8 = P4",(xc["S5"] = xc["P1"])="x Anfang S5 = P1",(xc["S7"] = xc["P3"])="x Anfang S7 = P3",(0 < (xc["A2"] - xc["S6"])*vx["S6"] + (yc["A2"] - yc["S6"])*vy["S6"])="A2 innerhalb trager",(- vx["S6"]*(vx["S6"] - xc["A2"] + xc["S6"]) - vy["S6"]*(vy["S6"] - yc["A2"] + yc["S6"]) < 0)="A2 innerhalb trager",(vy["S7"] = yc["P4"] - yc["P3"])="y Ende S7 = P4",(vx["S8"] = xc["P1"] - xc["P4"])="x Ende S8 = P1",(- vx["S6"]*vx["S7"] - vy["S6"]*vy["S7"] = 0)="S7 ortho S6",(- vx["S5"]*vx["S8"] - vy["S5"]*vy["S8"] = 0)="S8 ortho S5",(- vx["S7"]*vx["S8"] - vy["S7"]*vy["S8"] = 0)="S7 ortho S8",(vx["S5"]^2 + vy["S5"]^2 = 64.0)="S5 Laenge=8.0");
FXConOpt:=[];
FXCanvasOpt:=[];
NameCounter:=12;
FXuseLP:=TRUE;
FXuseSPH:=FALSE;
FXRandomR:=0.0;
FXText:="";
VisualProps:="A1:TRUE:TRUE:51,255,51,255;A2:TRUE:TRUE:51,255,51,255;P1:TRUE:TRUE:255,0,0,255;P2:TRUE:TRUE:255,0,0,255;P3:TRUE:TRUE:255,0,0,255;P4:TRUE:TRUE:255,0,0,255;S5:TRUE:FALSE:255,0,0,255;S6:TRUE:FALSE:255,0,0,255;S7:TRUE:FALSE:255,0,0,255;S8:TRUE:FALSE:255,0,0,255";

