// FeliX-Datei 
Config:=[xc["P1"] = -4.855072464, yc["P1"] = -1.539855072, xc["P2"] = 6.775362319, yc["P2"] = -0.5253623188, xc["P3"] = -5.826606629, yc["P3"] = 4.216026578, xc["P4"] = 5.803828155, yc["P4"] = 5.230519331, xc["P"] = -0.01138923684, yc["P"] = 4.723272954, xc["S6"] = -4.855072464, yc["S6"] = -1.539855072, vx["S6"] = -0.9715341646, vy["S6"] = 5.75588165, xc["S7"] = -5.826606629, yc["S7"] = 4.216026578, vx["S7"] = 5.815217392, vy["S7"] = 0.5072463766, xc["S8"] = -0.01138923684, yc["S8"] = 4.723272954, vx["S8"] = 5.815217392, vy["S8"] = 0.5072463766, xc["S9"] = 5.803828155, yc["S9"] = 5.230519331, vx["S9"] = 0.9715341641, vy["S9"] = -5.75588165];
Objects:=[["P1", "point"], ["P2", "point"], ["P3", "point"], ["P4", "point"], ["P", "point"], ["S6", "vector"], ["S7", "vector"], ["S8", "vector"], ["S9", "vector"]];
BasicObjects:=["P1", "P2"];
Equations:=[2*xc["P"] = xc["P3"] + xc["P4"], 2*yc["P"] = yc["P3"] + yc["P4"], (vx["S7"]^2 + vy["S7"]^2)^(1/2) = (vx["S8"]^2 + vy["S8"]^2)^(1/2), xc["S6"] = xc["P1"], yc["S6"] = yc["P1"], vx["S6"] = xc["P3"] - xc["P1"], vy["S6"] = yc["P3"] - yc["P1"], xc["S7"] = xc["P3"], yc["S7"] = yc["P3"], vx["S7"] = xc["P"] - xc["P3"], vy["S7"] = yc["P"] - yc["P3"], xc["S8"] = xc["P"], yc["S8"] = yc["P"], vx["S8"] = xc["P4"] - xc["P"], vy["S8"] = yc["P4"] - yc["P"], xc["S9"] = xc["P4"], yc["S9"] = yc["P4"], vx["S9"] = xc["P2"] - xc["P4"], vy["S9"] = yc["P2"] - yc["P4"], (vx["S7"]^2 + vy["S7"]^2)^(1/2) = (vx["S6"]^2 + vy["S6"]^2)^(1/2), (vx["S9"]^2 + vy["S9"]^2)^(1/2) = (vx["S6"]^2 + vy["S6"]^2)^(1/2), 2*(vx["S8"]^2 + vy["S8"]^2)^(1/2) = ((xc["P1"] - xc["P2"])^2 + (yc["P1"] - yc["P2"])^2)^(1/2)];
FelixCurves:=[["RC1", "ImplCurve", -(X*xc["P1"] + X*xc["P2"] + Y*yc["P1"] + Y*yc["P2"] - xc["P1"]*xc["P2"] - yc["P1"]*yc["P2"] - X^2 - Y^2)*(4*X^4 - 8*X^3*xc["P1"] - 8*X^3*xc["P2"] + 8*X^2*Y^2 - 8*X^2*Y*yc["P1"] - 8*X^2*Y*yc["P2"] + 5*X^2*xc["P1"]^2 + 14*X^2*xc["P1"]*xc["P2"] + 5*X^2*xc["P2"]^2 + 5*X^2*yc["P1"]^2 - 2*X^2*yc["P1"]*yc["P2"] + 5*X^2*yc["P2"]^2 - 8*X*Y^2*xc["P1"] - 8*X*Y^2*xc["P2"] + 16*X*Y*xc["P1"]*yc["P2"] + 16*X*Y*xc["P2"]*yc["P1"] - X*xc["P1"]^3 - 7*X*xc["P1"]^2*xc["P2"] - 7*X*xc["P1"]*xc["P2"]^2 - X*xc["P1"]*yc["P1"]^2 + 2*X*xc["P1"]*yc["P1"]*yc["P2"] - 9*X*xc["P1"]*yc["P2"]^2 - X*xc["P2"]^3 - 9*X*xc["P2"]*yc["P1"]^2 + 2*X*xc["P2"]*yc["P1"]*yc["P2"] - X*xc["P2"]*yc["P2"]^2 + 4*Y^4 - 8*Y^3*yc["P1"] - 8*Y^3*yc["P2"] + 5*Y^2*xc["P1"]^2 - 2*Y^2*xc["P1"]*xc["P2"] + 5*Y^2*xc["P2"]^2 + 5*Y^2*yc["P1"]^2 + 14*Y^2*yc["P1"]*yc["P2"] + 5*Y^2*yc["P2"]^2 - Y*xc["P1"]^2*yc["P1"] - 9*Y*xc["P1"]^2*yc["P2"] + 2*Y*xc["P1"]*xc["P2"]*yc["P1"] + 2*Y*xc["P1"]*xc["P2"]*yc["P2"] - 9*Y*xc["P2"]^2*yc["P1"] - Y*xc["P2"]^2*yc["P2"] - Y*yc["P1"]^3 - 7*Y*yc["P1"]^2*yc["P2"] - 7*Y*yc["P1"]*yc["P2"]^2 - Y*yc["P2"]^3 + xc["P1"]^3*xc["P2"] + 2*xc["P1"]^2*xc["P2"]^2 + xc["P1"]^2*yc["P1"]*yc["P2"] + 4*xc["P1"]^2*yc["P2"]^2 + xc["P1"]*xc["P2"]^3 + xc["P1"]*xc["P2"]*yc["P1"]^2 - 4*xc["P1"]*xc["P2"]*yc["P1"]*yc["P2"] + xc["P1"]*xc["P2"]*yc["P2"]^2 + 4*xc["P2"]^2*yc["P1"]^2 + xc["P2"]^2*yc["P1"]*yc["P2"] + yc["P1"]^3*yc["P2"] + 2*yc["P1"]^2*yc["P2"]^2 + yc["P1"]*yc["P2"]^3) = 0, X, Y]];
FXcomments:=[];
commentTable:=table();
FXConOpt:=[600, 100, 100, 3, 0.01, 15, 10, 3];
FXCanvasOpt:=[];
NameCounter:=1;
FXuseLP:=TRUE;
FXuseSPH:=FALSE;
FXRandomR:=0.0;
FXText:="";
VisualProps:="P:TRUE:TRUE:102,255,51,255;P1:TRUE:TRUE:255,0,0,255;P2:TRUE:TRUE:255,0,0,255;P3:TRUE:TRUE:255,0,0,255;P4:TRUE:TRUE:255,0,0,255;S6:TRUE:TRUE:255,0,0,255;S7:TRUE:TRUE:255,0,0,255;S8:TRUE:TRUE:255,0,0,255;S9:TRUE:TRUE:255,0,0,255";

