// FeliX-Datei 
Config:=[xc["A"] = -2.391304348, yc["A"] = 5.344202899, xc["B"] = -4.695384076, yc["B"] = -0.1957624991, ac["L3"] = 0.9233275663, bc["L3"] = -0.384013288, cc["L3"] = -4.260202151, xc["F"] = 0.1502557828, yc["F"] = -1.428553786, xc["S5"] = -4.695384076, yc["S5"] = -0.1957624991, vx["S5"] = 4.845639859, vy["S5"] = -1.232791287, xc["P6"] = -6.811594203, yc["P6"] = -3.822463768, xc["M"] = 4.057971014, yc["M"] = -3.025362319, xc["R8"] = 4.057971014, yc["R8"] = -3.025362319, rc["R8"] = 3.0, xc["R"] = 4.218455185, yc["R"] = -0.02965792159, xc["S10"] = -6.811594203, yc["S10"] = -3.822463768, vx["S10"] = 11.03004939, vy["S10"] = 3.792805847, xc["S"] = 4.301994424, yc["S"] = 7.264492754];
Objects:=[["A", "point"], ["B", "point"], ["L3", "line"], ["F", "point"], ["S5", "vector"], ["P6", "point"], ["M", "point"], ["R8", "circle"], ["R", "point"], ["S10", "vector"], ["S", "point"]];
BasicObjects:=["A", "P6", "M", "S"];
Equations:=[ac["L3"]*xc["A"] + bc["L3"]*yc["A"] = cc["L3"], ac["L3"]*xc["B"] + bc["L3"]*yc["B"] = cc["L3"], xc["S5"] = xc["B"], yc["S5"] = yc["B"], vx["S5"] = xc["F"] - xc["B"], vy["S5"] = yc["F"] - yc["B"], (xc["A"] - xc["B"])^2 + (yc["A"] - yc["B"])^2 = 36, vx["S5"]^2 + vy["S5"]^2 = 25, xc["R8"] = xc["M"], yc["R8"] = yc["M"], rc["R8"] = 3, rc["R8"]^2 = (xc["R"] - xc["R8"])^2 + (yc["R"] - yc["R8"])^2, xc["S10"] = xc["P6"], yc["S10"] = yc["P6"], vx["S10"] = xc["R"] - xc["P6"], vy["S10"] = yc["R"] - yc["P6"], 0 < (xc["F"] - xc["S10"])*vx["S10"] + (yc["F"] - yc["S10"])*vy["S10"], - vx["S10"]*(vx["S10"] - xc["F"] + xc["S10"]) - vy["S10"]*(vy["S10"] - yc["F"] + yc["S10"]) < 0, yc["F"]*vx["S10"] - xc["F"]*vy["S10"] = vx["S10"]*yc["S10"] - vy["S10"]*xc["S10"], xc["S"] = ((xc["F"] - xc["R"])^2 + (yc["F"] - yc["R"])^2)^(1/2)];
FelixCurves:=[];
FXcomments:=FXcomments;
commentTable:=table((ac["L3"]*xc["B"] + bc["L3"]*yc["B"] = cc["L3"])="B auf L3",(xc["R8"] = xc["M"])="R8=K(M,4.0)",(rc["R8"]^2 = (xc["R"] - xc["R8"])^2 + (yc["R"] - yc["R8"])^2)="R auf R8",(- vx["S10"]*(vx["S10"] - xc["F"] + xc["S10"]) - vy["S10"]*(vy["S10"] - yc["F"] + yc["S10"]) < 0)="F innerhalb trager",(vx["S10"] = xc["R"] - xc["P6"])="x Ende S10 = R",(rc["R8"] = 4.0)="R8=K(M,4.0)",(xc["S10"] = xc["P6"])="x Anfang S10 = P6",(xc["S5"] = xc["B"])="x Anfang S5 = B",(yc["R8"] = yc["M"])="R8=K(M,4.0)",(vy["S10"] = yc["R"] - yc["P6"])="y Ende S10 = R",(ac["L3"]*xc["A"] + bc["L3"]*yc["A"] = cc["L3"])="A auf L3",(yc["F"]*vx["S10"] - xc["F"]*vy["S10"] = vx["S10"]*yc["S10"] - vy["S10"]*xc["S10"])="F auf S10",(vx["S5"] = xc["F"] - xc["B"])="x Ende S5 = F",(0 < (xc["F"] - xc["S10"])*vx["S10"] + (yc["F"] - yc["S10"])*vy["S10"])="F innerhalb trager",(vy["S5"] = yc["F"] - yc["B"])="y Ende S5 = F",(yc["S10"] = yc["P6"])="y Anfang S10 = P6",(yc["S5"] = yc["B"])="y Anfang S5 = B",(vx["S5"]^2 + vy["S5"]^2 = 16.0)="S5 Laenge=4.0");
FXConOpt:=[];
FXCanvasOpt:=[];
NameCounter:=12;
FXuseLP:=TRUE;
FXuseSPH:=FALSE;
FXRandomR:=0.0;
FXText:="";
VisualProps:="A:TRUE:TRUE:255,0,0,255;B:TRUE:TRUE:255,0,0,255;F:TRUE:TRUE:255,0,0,255;L3:TRUE:TRUE:255,0,0,255;M:TRUE:TRUE:255,0,0,255;P6:TRUE:TRUE:255,0,0,255;R:TRUE:TRUE:255,0,0,255;R8:TRUE:TRUE:255,0,0,255;S:TRUE:TRUE:255,0,0,255;S10:TRUE:TRUE:255,0,0,255;S5:TRUE:TRUE:255,0,0,255";

