/* Felix for MuPAD V 0.0.1 - Version Feb07 */

numeric::fsolve(zzz=5,zzz):


FXdebug:=FALSE:

FXallowJava:=TRUE:   // Sind Aufrufe nach Java zulssig?

if domtype(FelixPath)=DOM_IDENT then FelixPath:="c:\\oldenburg\\MuPAD\\Felix\\" end_if:
//FelixPath$$$$

unprotect(numeric): read(FelixPath."fsolve.mu"):

FelixPathJava:= stringlib::subs(FelixPath,"\\"="/"):

convertFilenameForJava:=proc(s) begin stringlib::subs(s,"\\"="/") end_proc:

if version()=[3,1,1] then 
  READPATH:= FelixPath, FelixPath."donlpParser\\", READPATH: 
elif version()=[4,0,1] then 
  READPATH:= FelixPath, FelixPath."donlpParser401\\", READPATH: 
elif version()=[4,0,2] then 
  READPATH:= FelixPath, FelixPath."donlpParser402\\", READPATH: 
else
print("Vorsicht! Diese MuPAD-Version ".expr2text(version())." wird nicht untersttzt!");
READPATH:= FelixPath, FelixPath."donlpParser\\", READPATH: 
end_if:


export(module("dlp2mup")): 
read("donlp2.mu"):

module(expr2bitmap):

package("java"): 
java::start(ClassPath=FelixPath."classes;".FelixPath."classes\\janino.jar",
   UseOptionList=["-Xincgc","-Xms64M"]): //  
//original: java::start(ClassPath=FelixPath."classes;".FelixPath."classes\\janino.jar"):
java::console():

// global constants

numeps:=0.0000000001:

FXConOpt:=[]:
FXCanvasOpt:=[]:

FXText:="": // Hinweis-Text im Geo-fenster

delete PIx,PIy: // Variablen fr automatisch erzeugte Implizite Gleichungen 

// Init

FelixNew:=proc()
begin
	numeps:=0.0000000001:
	Config:= []: // Liste [xc("a")=5, ...]    fr subs geeignet
	NameCounter:=1:
	Objects:=[]: // Liste [ [name,typ].....]
	FelixTypes:={"point","line","circle","vector","FuncCurve","ParaCurve","ImplCurve"}:
	BasicObjects:=[]: // Liste der Namen
	Equations:=[]:
	FXcomments:=[]:
	commentTable:=table();
	FXText:="";
    FelixCurves:=[]:
end_proc:

// Saving

felixSave:=proc(datei:DOM_STRING)
local s,a,sj;
begin
	a:=args();
    datei:=stringlib::subs(datei,"$"="\\");
	s:="// FeliX-Datei \n";
	s:=s."Config:=".expr2text(Config).";\n";
	s:=s."Objects:=".expr2text(Objects).";\n";
	s:=s."BasicObjects:=".expr2text(BasicObjects).";\n";
	s:=s."Equations:=".expr2text(Equations).";\n";
	s:=s."FelixCurves:=".expr2text(FelixCurves).";\n";
	s:=s."FXcomments:=".expr2text(FXcomments).";\n";
	s:=s."commentTable:=".expr2text(commentTable).";\n";
	s:=s."FXConOpt:=".expr2text(FXConOpt).";\n";
	s:=s."FXCanvasOpt:=".expr2text(FXCanvasOpt).";\n";
	s:=s."NameCounter:=".expr2text(NameCounter).";\n";
	s:=s."FXuseLP:=".expr2text(FXuseLP).";\n";
	s:=s."FXuseSPH:=".expr2text(FXuseSPH).";\n";    
	s:=s."FXRandomR:=".expr2text(FXRandomR).";\n";   
	s:=s."FXText:=".expr2text(FXText).";\n";   
	if nops(a)=2 then sj:=args(2);
    	if not(domtype(sj)=DOM_STRING) then sj:=expr2text(sj); end_if;
	else sj:=""; 
	end_if;
	s:=s."VisualProps:=".expr2text(sj).";\n";
	fprint(Unquoted,Text,datei,s):
end_proc:

felixLoad:=proc(datei:DOM_STRING) // ohne repaint
local res,i,ob,na,typ;
begin
	FelixNew();
    datei:=stringlib::subs(datei,"$"="\\");
	read(datei,Quiet);
	if FXallowJava then
		java::DGSFelix::setCounter(felixHandle,NameCounter-1);
		java::DGSFelix::setFelixText(felixHandle,FXText);
	end_if;
	for i from 1 to nops(Objects) do
		ob:=Objects[i]; typ:=ob[2]; na:=ob[1];
    	if typ="point" then 
			if has(BasicObjects,na) then 
				if FXallowJava then
					java::DGSFelix::addPoint(felixHandle,na,float(getVar(xc[na])),float(getVar(yc[na])),TRUE);
				end_if
 		    else
				if FXallowJava then 
				java::DGSFelix::addPoint(felixHandle,na,float(getVar(xc[na])),float(getVar(yc[na])),FALSE);
				end_if
			end_if
    	elif typ="line" then 
				if FXallowJava then 
				java::DGSFelix::addLine(felixHandle,na,float(getVar(ac[na])),float(getVar(bc[na])),float(getVar(cc[na])));
                end_if;
   	elif typ="circle" then 
				if FXallowJava then 
				   java::DGSFelix::addCircle(felixHandle,na,float(getVar(xc[na])),float(getVar(yc[na])),float(getVar(rc[na])));
				end_if;
  	   	elif typ="vector" then 
				if FXallowJava then java::DGSFelix::addVector(felixHandle,na,float(getVar(xc[na])),float(getVar(yc[na])),
											float(getVar(vx[na])),float(getVar(vy[na])),FALSE); end_if;
		end_if;
	end_for;
    ConfigStr()."#".VisualProps."#".EqDataasString()
end_proc:

ConfigStr:=proc() 
  local obj,i,res;
begin
	res:=""; 
	for i from 1 to nops(Objects) do
    	if i>1 then res:=res.";"; end_if;
		obj:=Objects[i];
		res:=res.obj[2].",".obj[1].",";
		if obj[2]="point" then res:=res.expr2text(getVar(xc[obj[1]])).",".expr2text(getVar(yc[obj[1]]))
		elif obj[2]="circle" then res:=res.expr2text(getVar(xc[obj[1]])).",".expr2text(getVar(yc[obj[1]])).",".expr2text(getVar(rc[obj[1]]))
		elif obj[2]="line" then res:=res.expr2text(getVar(ac[obj[1]])).",".expr2text(getVar(bc[obj[1]])).",".expr2text(getVar(cc[obj[1]]))
		elif obj[2]="vector" then res:=res.expr2text(getVar(xc[obj[1]])).",".expr2text(getVar(yc[obj[1]])).",".expr2text(getVar(vx[obj[1]])).",".expr2text(getVar(vy[obj[1]]))
       end_if;
	   if isBasicObj(obj[1]) then res:=res.",TRUE"; else res:=res.",FALSE"; end_if; 
	end_for;
	res
end_proc:

// Data structures-----------------------------------------------------

FelixVarHeads:=[xc,yc,ac,bc,cc,rc,vx,vy,vc]:  // vc sind beliebige (ungeometrische) Variablen 

// Variablen & co

Config:= []: // Liste [xc("a")=5, ...]    fr subs geeignet
Variables:= proc() begin map(Config,x->op(x,1)) end_proc:
Values:= proc() begin map(Config,x->op(x,2)) end_proc:

insertValues:= expr -> subs(expr,Config):
insertBasicValues:=proc(expr)
local i, sl;
begin
	sl:=[];
	for i from 1 to nops(Config) do
    	if isBasicVar(op(Config[i],1)) then sl:=[op(sl),Config[i]]; end_if;
	end_for;
	return(subs(expr,sl));
end_proc:

insertValuesOf:=proc(expr,a:DOM_LIST) //a ist Liste von Objekten oder Variablen
local i, sl;
begin
	sl:=[];
	for i from 1 to nops(Config) do
	    if contains(a,op(Config[i],1))>0 or 
		   contains(a,op(op(Config[i],1),2))>0
 		then sl:=[op(sl),Config[i]]; end_if;
	end_for;
	return(subs(expr,sl));
end_proc:

setVar:=proc(var,value) // in Mupad und java 
local i;
begin
	for i from 1 to nops(Config) do
		if op(Config[i],1)=var then Config[i]:= var=value; break; end_if;
	end_for;
	JavaSetvar(var,value); // setzt Wert in java
	value;
end_proc:

setVar0:=proc(var,value)  // Nur in MuPAD !!! 
local i;
begin
	for i from 1 to nops(Config) do
		if op(Config[i],1)=var then Config[i]:= var=value; break; end_if;
	end_for;
	value;
end_proc:

getVar:=proc(var) 
local i;
begin
	for i from 1 to nops(Config) do
		if op(Config[i],1)=var then return(op(Config[i],2));  end_if;
	end_for;
	null()
end_proc:


NameCounter:=1:

IncNC:= proc() begin NameCounter:=NameCounter+1; end_proc:

newname:=proc(s:DOM_STRING)
local s0;
begin
	while TRUE do 
		s0:=s.expr2text(NameCounter); NameCounter:=NameCounter+1;
		if not(isObj(s0)) then return(s0); end_if;
    end_while;
end_proc:

// Objekte

Objects:=[]: // Liste [ [name,typ].....]
FelixTypes:={"point","line","circle","vector","FuncCurve","ParaCurve","ImplCurve"}:
BasicObjects:=[]: // Liste der Namen

FelixCurves:=[]: // Liste der Kurven mit Definitionsinfos

isObj:= x -> bool(has(Objects,x)):
isBasicObj:= obj -> bool(has(BasicObjects,obj)):

setBasic:=proc(obj:DOM_STRING) 
begin
  if not(has(BasicObjects,obj)) then BasicObjects:=[op(BasicObjects),obj]; end_if;
end_proc:
setNonBasic:=proc(obj:DOM_STRING) 
local i;
begin
	i:=1;
	while i<=nops(BasicObjects) do
		if BasicObjects[i]=obj then BasicObjects[i]:=null(); else i:=i+1; end_if;
    end_while;
end_proc:
 
getType:=proc(obj:DOM_STRING)
local i;
begin
    for i from 1 to nops(Objects) do
		if Objects[i][1]=obj then return(Objects[i][2]); end_if;
    end_for;
    for i from 1 to nops(FelixCurves) do
		if FelixCurves[i][1]=obj then return(FelixCurves[i][2]); end_if;
    end_for;
	return(null());
end_proc:

varsOf:= proc(obj:DOM_STRING) 
local typ;
begin
	typ:=getType(obj);
	if typ=null() then return({}); end_if;
	if typ="point" then return({xc[obj],yc[obj]}); end_if;
	if typ="circle" then return({xc[obj],yc[obj],rc[obj]}); end_if;
	if typ="line" then return({ac[obj],bc[obj],cc[obj]}); end_if;
	if typ="vector" then return({xc[obj],yc[obj],vx[obj],vy[obj]}); end_if;
    return({});
end_proc:

deleteObject:=proc(obj:DOM_STRING) 
begin
  deleteObject0(obj); 
  if FXallowJava then java::DGSFelix::deleteObject(felixHandle,obj) end_if;
end_proc:

deleteObject0:=proc(obj:DOM_STRING) 
local i;
begin
  i:=1;
  while i<=nops(Equations) do
  	if has(Equations[i],obj) then Equations[i]:=null(); else i:=i+1; end_if;
  end_while;
  i:=1;
  while i<=nops(Objects) do
  	if has(Objects[i],obj) then Objects[i]:=null(); else i:=i+1; end_if;
  end_while;
  i:=1;
  while i<=nops(Config) do
  	if has(Config[i],obj) then Config[i]:=null(); else i:=i+1; end_if;
  end_while;
  i:=1;
  while i<=nops(FelixCurves) do
  	if FelixCurves[i][1]=obj then FelixCurves[i]:=null(); else i:=i+1; end_if;
  end_while;
end_proc:

// Gleichungen

Equations:=[]:



getEquations:= ()-> select(Equations,eq->bool(type(eq)="_equal")):
getInEquations:= ()-> select(Equations,eq->bool(type(eq)="_less" or type(eq)="_leequal")):

addEquationComment:= proc(e,c) begin addComment(e,c);  addEquation(e) end_proc:

addEquation:=proc(e) 
begin
	if domtype(e)=DOM_SET or domtype(e)=DOM_LIST then map(e,addEquation); return(); end_if;
	if type(e)="_equal" or type(e)="_less" or type(e)="_leequal" then 
	   Equations:=[op(Equations),e];
 	   if FXallowJava then updateEqTable(); end_if; 
	   return(e); 
	end_if:
    Equations:=[op(Equations),e=0];
	if FXallowJava then updateEqTable(); end_if; 
	return(Equations[nops(Equations)]);
end_proc:


getEquationOf:=proc(obj:DOM_STRING,x,y)
local typ,l;
begin
	typ:=getType(obj);
	if typ=null() then error("Unbekannter Typ");
	elif typ="point" then return((x-xc[obj])^2+(y-yc[obj])^2=0);
	elif typ="line" then return(x*ac[obj]+y*bc[obj]=cc[obj]);
	elif typ="vector" then return(-vy[obj]*(x-xc[obj])+vx[obj]*(y-yc[obj])=0);
	elif typ="circle" then return((x-xc[obj])^2+(y-yc[obj])^2=rc[obj]^2);
	elif typ="FuncCurve" then return(y=subs(getCurveOp(obj,1),getCurveOp(obj,2)=x));
	elif typ="ParaCurve" then 
	   l:=getCurveOps(obj);
       if nops(l)=8 then return(subs(l[8],PIx=x,PIy=y)) 
	                else error("Parametric equation not implicitable!"); end_if; 
	elif typ="ImplCurve" then return(subs(getCurveOp(obj,1),getCurveOp(obj,2)=x,getCurveOp(obj,3)=y));
	else error("Unbekannter Typ");
	end_if;
end_proc:

defects:= () -> map(Equations,proc(e)
   begin
   if type(e)="_equal" then makeReal(float(eval(insertValues(op(e,1)-op(e,2))))) 
   elif type(e)="_less" or type(e)="_leequal" then  makeReal(min(0,float(eval(insertValues(op(e,2)-op(e,1))))))
   else float(insertValues(e));
   end_if;
   end_proc):

 makeReal:=proc(x) begin if domtype(x)=DOM_COMPLEX then abs(x) else x end_if end_proc:
   
 //------------------ Browser ------------------------------


renameObject:=proc(oldName,newName)
begin
	if(not(domtype(oldName)=DOM_STRING)) then oldName=expr2text(oldName); end_if; 
	if(not(domtype(newName)=DOM_STRING)) then newName=expr2text(newName); end_if; 
	if(has(Objects,newName)) then error("Neuer Name existiert schon!"); end_if;
	if(not(has(Objects,oldName))) then error("Unbekanntes Objekt!"); end_if;
	commentTable:=table(traverseSubsString(subs([op(commentTable)],oldName=newName),oldName,newName));
	Equations:=subs(Equations,oldName=newName);
	Config:=subs(Config,oldName=newName);
	Objects:=subs(Objects,oldName=newName);
	BasicObjects:=subs(BasicObjects,oldName=newName);
end_proc:


// outdated: Brower jetzt interiert EqBrowserHandle:=java::EqTable::mupadmain():

updateEqTable:= proc()
begin
  java::DGSFelix::updateEqTable(felixHandle,EqDataasString());
end_proc:
	
UpdateEqBrowser:=proc()  begin
	java::EqTable::updateList(EqBrowserHandle,map(Equations,expr2text),defects(),comments());
end_proc:

EqDataasString:=proc() // Liefert String nops(equations):Eq1:defekt1:....
local res,iL,d,Ld;
begin
    L:=map(sqrt2SQRT(Equations),expr2text);
	d:=defects(); 
	Ld:=[op(L),op(d),op(comments())];
	res:="";
	for i from 1 to nops(Ld) do 
		res:=res.expr2text(Ld[i]);
		if i<nops(Ld) then res:=res.":"; end_if;
	end_for;
	res
end_proc:

DefectString:=proc() // Liefert String nops(equations):Eq1:defekt1:....
local res,d;
begin
	d:=defects(); 
	res:="";
	for i from 1 to nops(d) do 
		res:=res.expr2text(d[i]);
		if i<nops(d) then res:=res.":"; end_if;
	end_for;
	res
end_proc:

commentTable:=table():
comments:=proc() begin map(Equations,getComment) end_proc:
addComment:=proc(e,c) begin commentTable[e]:=c; end_proc:
getComment:=proc(e) 
local r;
save a;
begin
  delete a;
  r:=commentTable[e];
  if op(a[1],0)=op(r,0) then "" else r end_if
end_proc:


EqChanged:=proc(i,neweq)
begin
	if domtype(neweq)=DOM_STRING then neweq:=text2expr(neweq); end_if;
	neweq:=eval(neweq);
	if not(checkVars(neweq)) then error("ERROR: Unkown Variables!"); end_if;
	if not(checkFuncs(neweq)) then FunProb:=neweq; error("ERROR: Unknown function"); end_if;
	if i<=nops(Equations) then Equations[i]:=neweq; 
	else error("ERROR: Dimension Falsch.");
	end_if;
end_proc:

EqDeleted:=proc(r)
begin
	if r<=nops(Equations) then Equations[r]:=null(); 
	end_if;
end_proc:

deleteEquations:=proc(L:DOM_LIST)
local i; save todel;
begin
delete todel;
for i from 1 to nops(Equations) do
  if has(L,i) then Equations[i]:=todel; end_if;
end_for;
Equations:=subs(Equations,todel=null());
end_proc:

EqAppended:=proc() begin Equations:=[op(Equations),0=0]: end_proc:


// calling Felix directly ------------------------------------------------------

// alle Variablenwerte werden nur mupad -> java transportiert!!!!

felixHandle:=java::DGSFelix::mupadmain("G1",FelixPathJava): /* bez of table that contains construction data */


callFelix:= proc(cmd:DOM_STRING,args:DOM_LIST)
begin
	if FXallowJava then java::DGSFelix::FelixCommand(felixHandle,cmd,args) end_if;
end_proc:

setCoords:= proc(ob:DOM_STRING,c:DOM_LIST)  /* with repaint */
begin
	if FXallowJava then java::DGSFelix::setCoords(felixHandle,ob,float(c)) end_if;
end_proc:

setcoords:= proc(ob:DOM_STRING,c:DOM_LIST) /* without repaint */
begin
	if FXallowJava then java::DGSFelix::setcoords(felixHandle,ob,float(c)) end_if;
end_proc:

JavaSetvar:= proc(v,x) /* without repaint */
begin
  if domtype(v)=DOM_STRING then
	if FXallowJava then java::DGSFelix::setvar(felixHandle,v,float(x))end_if;
  else
	if FXallowJava then java::DGSFelix::setvar(felixHandle,expr2text(v),float(x)) end_if;
  end_if;
end_proc:


felixRepaint:=proc() begin if FXallowJava then java::DGSFelix::repaint(felixHandle); end_if; end_proc:
FelixRepaint:=felixRepaint:


Underscore2Quote:=proc(x) begin stringlib::subs(x,"_"="\"") end_proc:

ObjtoString:=proc(obj:DOM_STRING) //liefert String fr die bearbeitung durch Java ??? Ergnzen: farbe etc...
local typ,res;
begin
	typ:=getType(obj); res:=typ.":".obj.":"; 
	if typ="point" then res:=res.expr2text(getVar(xc[obj])).":".expr2text(getVar(yc[obj])).":".expr2text(isBasicObj(obj)).":".expr2text(isBasicObj(obj));
	elif typ="line" then res:=res.expr2text(getVar(ac[obj])).":".expr2text(getVar(bc[obj])).":".expr2text(getVar(cc[obj])).":".expr2text(isBasicObj(obj));
	elif typ="circle" then res:=res.expr2text(getVar(xc[obj])).":".expr2text(getVar(yc[obj])).":".expr2text(getVar(rc[obj])).":".expr2text(isBasicObj(obj));
	elif typ="vector" then res:=res.expr2text(getVar(xc[obj])).":".expr2text(getVar(yc[obj])).":".
				expr2text(getVar(vx[obj])).":".expr2text(getVar(vy[obj])).":"."FALSE".":".expr2text(isBasicObj(obj));     end_if;
    return(res);
end_proc:

/* adding Objects -----------------------------------------*/


addBasicPoint0:= (x,y) -> addBasicPoint(newname("P"),x,y):
addPoint0:= (x,y) -> addPoint(newname("P"),x,y):

addBasicPoint:=proc(bez:DOM_STRING,x,y) 
begin
	if isObj(bez) then error("Objekt existiert schon!"); end_if;
	x:=float(x); y:=float(y);
	if not(domtype(x)=DOM_FLOAT) or not(domtype(y)=DOM_FLOAT) then error("Koordinaten nicht nummerisch!") end_if;
    Objects:=[op(Objects),[bez,"point"]];
	Config:=[op(Config),xc[bez]=float(x),yc[bez]=float(y)];
	BasicObjects:=[op(BasicObjects),bez];
	if FXallowJava then java::DGSFelix::addPoint(felixHandle,bez,float(x),float(y),TRUE); end_if; 
	return(bez);
end_proc:
addPoint:=proc(bez:DOM_STRING,x,y) 
begin
	if isObj(bez) then error("Objekt existiert schon!"); end_if;
	x:=float(x); y:=float(y);
	if not(domtype(x)=DOM_FLOAT) or not(domtype(y)=DOM_FLOAT) then error("Koordinaten nicht nummerisch!") end_if;
    Objects:=[op(Objects),[bez,"point"]];
	Config:=[op(Config),xc[bez]=float(x),yc[bez]=float(y)];
	if FXallowJava then java::DGSFelix::addPoint(felixHandle,bez,float(x),float(y),FALSE); end_if;
	return(bez);
end_proc:

addCircle0:= (x,y,r) -> addCircle(newname("C"),x,y,r):
addCircle:=proc(bez:DOM_STRING,x,y,r) 
begin
	if isObj(bez) then error("Objekt existiert schon!"); end_if;
	x:=float(x); y:=float(y); r:=float(r);
	if not(domtype(x)=DOM_FLOAT) or not(domtype(y)=DOM_FLOAT) or not(domtype(r)=DOM_FLOAT) then 
	    error("Koordinaten nicht nummerisch!") end_if;
    Objects:=[op(Objects),[bez,"circle"]];
	Config:=[op(Config),xc[bez]=float(x),yc[bez]=float(y),rc[bez]=float(r)];
	if FXallowJava then java::DGSFelix::addCircle(felixHandle,bez,float(x),float(y),float(r)); end_if; 
	return(bez);
end_proc:

addLine0:= (a,b,c) -> addLine(newname("L"),a,b,c):
addLine:=proc(bez:DOM_STRING,a,b,c) 
begin
	if isObj(bez) then error("Objekt existiert schon!"); end_if;
	a:=float(a); b:=float(b); c:=float(c);
	if not(domtype(a)=DOM_FLOAT) or not(domtype(b)=DOM_FLOAT) or not(domtype(c)=DOM_FLOAT) then 
	    error("Koordinaten nicht nummerisch!") end_if;
    Objects:=[op(Objects),[bez,"line"]];
	Config:=[op(Config),ac[bez]=float(a),bc[bez]=float(b),cc[bez]=float(c)];
	if FXallowJava then java::DGSFelix::addLine(felixHandle,bez,float(a),float(b),float(c)); end_if; 
	return(bez);
end_proc:

addVector0:= (x,y,xx,yy) -> addVector(newname("V"),x,y,xx,yy):
addVector:=proc(bez:DOM_STRING,x,y,xx,yy) 
begin
	if isObj(bez) then error("Objekt existiert schon!"); end_if;
	x:=float(x); y:=float(y); xx:=float(xx); yy:=float(yy);
	if not(domtype(x)=DOM_FLOAT) or not(domtype(y)=DOM_FLOAT) or not(domtype(xx)=DOM_FLOAT) 
	    or not(domtype(yy)=DOM_FLOAT)
	then 
	    error("Koordinaten nicht nummerisch!") end_if;
    Objects:=[op(Objects),[bez,"vector"]];
	Config:=[op(Config),xc[bez]=float(x),yc[bez]=float(y),vx[bez]=float(xx),vy[bez]=float(yy)];
	if FXallowJava then java::DGSFelix::addVector(felixHandle,bez,float(x),float(y),float(xx),float(yy),FALSE); end_if;
	return(bez);
end_proc:

// muss noch berarbeitet werden !!!!!!!!!!!!
addFreeCurve:=proc(bez:DOM_STRING,x:DOM_LIST,y:DOM_LIST) 
  begin
    Objects:=[op(Objects),[bez,"FreeCurve"]];
	FelixCurves:=[op(FelixCurves),[bez,"FreeCurve",x,y]];
    if FXallowJava then java::DGSFelix::addFreeCurve(felixHandle,bez,map(x,float),map(y,float)); end_if; 
  end_proc:

addFuncCurve:=proc(bez:DOM_STRING,termy,var) 
local i,alt;
  begin 
    if domtype(var)=DOM_STRING then var:=text2expr(var); end_if;
    if domtype(termy)=DOM_STRING then termy:=text2expr(termy); end_if;
    if not(checkVars(termy,{var})) then error("ERROR: Unkown Variables:".expr2text([termy,domtype(termy),var,domtype(var)])); end_if;
    alt:=FALSE;
    for i from 1 to nops(FelixCurves) do
 	  if FelixCurves[i][1]=bez then alt:=TRUE; 
     		FelixCurves[i]:=[bez,"FuncCurve",termy,var]; break;
	  end_if;
    end_for;
    if not(alt) then FelixCurves:=[op(FelixCurves),[bez,"FuncCurve",termy,var]];
    		Objects:=[op(Objects),[bez,"FuncCurve"]];
    end_if;
  if FXallowJava then if alt then java::DGSFelix::modifyFuncCurve(felixHandle,bez,toStr(termy),toStr(var)); 
  else java::DGSFelix::addFuncCurve(felixHandle,bez,toStr(float(termy)),toStr(var)); end_if; end_if;
  end_proc:

getFunCurveTerm:=proc(nam:DOM_STRING)
begin
  for i from 1 to nops(FelixCurves) do
    if FelixCurves[i][1]=nam then return(FelixCurves[i][3]); end_if;
  end_for;
  error("Kurve ".nam." existiert nicht!");
end_proc:
getFunCurveVar:=proc(nam:DOM_STRING)
begin
  for i from 1 to nops(FelixCurves) do
    if FelixCurves[i][1]=nam then return(FelixCurves[i][4]); end_if;
  end_for;
  error("Kurve ".nam." existiert nicht!");
end_proc:


addParaCurve:=proc(bez:DOM_STRING,termx,termy,var,t0,t1) 
  local ieq,i,alt;
  begin 
    if domtype(termx)=DOM_STRING then termx:=text2expr(termx); end_if;
    if domtype(termy)=DOM_STRING then termy:=text2expr(termy); end_if;
    if domtype(var)=DOM_STRING then var:=text2expr(var); end_if;
    if domtype(t0)=DOM_STRING then t0:=text2expr(t0); end_if;
    if domtype(t1)=DOM_STRING then t1:=text2expr(t1); end_if;
    if not(checkVars({termx,termy},{var})) then error("ERROR: Unkown Variables!"); end_if;
    if 0=traperror((ieq:=simplify(Elim2(termx,termy,PIx,PIy,var))),10) then
	  if ieq=FAIL then ieq=null(); end_if;
	else ieq=null(); end_if;
    alt:=FALSE;
    for i from 1 to nops(FelixCurves) do
 	  if FelixCurves[i][1]=bez then alt:=TRUE; 
     		FelixCurves[i]:=[bez,"ParaCurve",termx,termy,var,float(t0),float(t1),ieq]; break;
	  end_if;
    end_for;
    if not(alt) then 
    		FelixCurves:=[op(FelixCurves),[bez,"ParaCurve",termx,termy,var,float(t0),float(t1),ieq]];
	    	Objects:=[op(Objects),[bez,"ParaCurve"]];
    end_if;
  if FXallowJava then java::DGSFelix::modifyParaCurve(felixHandle,bez,
                   toStr(float(termx)),toStr(float(termy)),toStr(var),float(t0),float(t1)); end_if;  
  end_proc:

Elim2:=proc(xterm,yterm,x,y,v) 
local sol,ve,xe,ye,res;
begin 
[xe,ye,ve]:=inertFV([xterm-x,yterm-y,v]);
if 0=traperror((res:=groebner::eliminate([xe,ye],[ve])),4) then
if nops(res)=1 then return(inertFVinverse(res[1]=0)); end_if;
end_if;
if 0=traperror((sol:=solve(xe=0,ve,IgnoreSpecialCases,PrincipalValue)),4) then 
if nops(sol)>=1 then return(inertFVinverse(subs(ye=0,ve=sol[1]))); end_if;
end_if;
if 0=traperror((sol:=solve(ye=0,ve,IgnoreSpecialCases,PrincipalValue)),4) then 
if nops(sol)>=1 then return(inertFVinverse(subs(xe=0,ve=sol[1]))); end_if;
end_if;
FAIL
end_proc:

getParaCurveTermx:=proc(nam:DOM_STRING)
begin
  for i from 1 to nops(FelixCurves) do
    if FelixCurves[i][1]=nam then return(FelixCurves[i][3]); end_if;
  end_for;
  error("Kurve ".nam." existiert nicht!");
end_proc:

getParaCurveTermy:=proc(nam:DOM_STRING)
begin
  for i from 1 to nops(FelixCurves) do
    if FelixCurves[i][1]=nam then return(FelixCurves[i][4]); end_if;
  end_for;
  error("Kurve ".nam." existiert nicht!");
end_proc:

getParaCurveVar:=proc(nam:DOM_STRING)
begin
  for i from 1 to nops(FelixCurves) do
    if FelixCurves[i][1]=nam then return(FelixCurves[i][5]); end_if;
  end_for;
  error("Kurve ".nam." existiert nicht!");
end_proc:

getParaCurveT0:=proc(nam:DOM_STRING)
begin
  for i from 1 to nops(FelixCurves) do
    if FelixCurves[i][1]=nam then return(FelixCurves[i][6]); end_if;
  end_for;
  error("Kurve ".nam." existiert nicht!");
end_proc:

getParaCurveT1:=proc(nam:DOM_STRING)
begin
  for i from 1 to nops(FelixCurves) do
    if FelixCurves[i][1]=nam then return(FelixCurves[i][7]); end_if;
  end_for;
  error("Kurve ".nam." existiert nicht!");
end_proc:


addImplCurve:=proc(bez:DOM_STRING,term,varx,vary) 
local alt, i;
  begin 
    if domtype(varx)=DOM_STRING then varx:=text2expr(varx); end_if;
    if domtype(vary)=DOM_STRING then vary:=text2expr(vary); end_if;
    if domtype(term)=DOM_STRING then term:=text2expr(term); end_if;
    if not(checkVars(term,{varx,vary})) then error("ERROR: Unkown Variables!"); end_if;
    alt:=FALSE;
    for i from 1 to nops(FelixCurves) do
 	  if FelixCurves[i][1]=bez then alt:=TRUE; 
     		FelixCurves[i]:=[bez,"ImplCurve",term,varx,vary]; break;
	  end_if;
    end_for;
    if not(alt) then FelixCurves:=[op(FelixCurves),[bez,"ImplCurve",term,varx,vary]];
    		Objects:=[op(Objects),[bez,"ImplCurve"]];
    end_if;
  if FXallowJava then if alt then 
     java::DGSFelix::modifyImplCurve(felixHandle,bez,toStr(float(eq2term(term))),toStr(varx),toStr(vary)); 
     else 
     java::DGSFelix::addImplCurve(felixHandle,bez,toStr(float(eq2term(term))),toStr(varx),toStr(vary)); 
 		   end_if;end_if;  
  end_proc:

getImplCurveVarx:=proc(nam:DOM_STRING)
begin
  for i from 1 to nops(FelixCurves) do
    if FelixCurves[i][1]=nam then return(FelixCurves[i][4]); end_if;
  end_for;
  error("Kurve ".nam." existiert nicht!");
end_proc:
getImplCurveVary:=proc(nam:DOM_STRING)
begin
  for i from 1 to nops(FelixCurves) do
    if FelixCurves[i][1]=nam then return(FelixCurves[i][5]); end_if;
  end_for;
  error("Kurve ".nam." existiert nicht!");
end_proc:
getImplCurveTerm:=proc(nam:DOM_STRING)
begin
  for i from 1 to nops(FelixCurves) do
    if FelixCurves[i][1]=nam then return(FelixCurves[i][3]); end_if;
  end_for;
  error("Kurve ".nam." existiert nicht!");
end_proc:


addFuncCurveInterval:=proc(bez,termy,var,t0,t1) 
  begin 
    if domtype(var)=DOM_STRING then var:=text2expr(var); end_if;
    if domtype(termy)=DOM_STRING then termy:=text2expr(termy); end_if;
    if not(checkVars(termy,{var})) then error("ERROR: Unkown Variables!"); end_if;
	FelixCurves:=[op(FelixCurves),[bez,"FuncCurve",termy,var,t0,t1]];
    Objects:=[op(Objects),[bez,"FuncCurve"]];
  if FXallowJava then java::DGSFelix::addFuncCurve(felixHandle,bez,toStr(termy),toStr(var),float(t0),float(t1)); end_if; 
  end_proc:


getCurveOp:=proc(na,n)  // Findet Kurven-Bestandteile aus Namen n=0: Typ, n=1 1.term etc....
local i;
begin
  for i from 1 to nops(FelixCurves) do   if FelixCurves[i][1]=na then 
      return(FelixCurves[i][n+2])
    end_if;
  end_for;
""
end_proc:

getCurveOps:=proc(na)  
local i;
begin
  for i from 1 to nops(FelixCurves) do   if FelixCurves[i][1]=na then 
      return(FelixCurves[i])
    end_if;
  end_for;
FAIL
end_proc:


// Objekt mit Eigenschaften hinzufgen

protokoll:=[]:

addPointOn0:= (x,y,t) -> addPointOn(newname("P"),x,y,t):
addPointOn:=proc(oname:DOM_STRING,x,y,traeger:DOM_STRING)
  local xy;
begin 
    xy:=projectTo(float([x,y]),traeger); 
	addPoint(oname,op(xy));
	addEquationPointOn(oname,traeger);
	oname
end_proc:

addMidPoint0:= (a,b) -> addMidPoint(newname("P"),a,b):
addMidPoint:=proc(m:DOM_STRING,a:DOM_STRING,b:DOM_STRING)
  local p;
begin
	if getType(a)<>"point" or getType(b)<>"point" then error("Punkt ntig!"); end_if;
	p:=addPoint(m,0.5*(getVar(xc[a])+getVar(xc[b])),0.5*(getVar(yc[a])+getVar(yc[b])));
    addEquationMidPoint(m,a,b);
	m
end_proc:

FXIntersectionHint:=[0,0]:
FXLastDown:=[0,0]:



addIntersection0:= (a,b) -> addIntersection(newname("P"),a,b):
addIntersection:=proc(na:DOM_STRING,a:DOM_STRING,b:DOM_STRING)
  local xx,yy,xt,yt,i,sol,p,e1,e2;
  save x,y;
begin
	delete x,y;
	assume(x,Type::Real);assume(y,Type::Real);
	e1:=insertValues(getEquationOf(a,x,y));
	e2:=insertValues(getEquationOf(b,x,y)); 
	if TRUE then // Algo mit fsolve
  	  //print([e1,e2],[x=FXIntersectionHint[1],y=FXIntersectionHint[2]]);
	  sol:=numeric::fsolve([e1,e2],[x=FXIntersectionHint[1],y=FXIntersectionHint[2]]);
	  if sol=FAIL then error("ERROR:addIntersection: Existieret nicht!"); end_if;
	  xx:=subs(x,sol); yy:=subs(y,sol);
	else // Algo mit solve  
	sol:=numeric::solve([e1,e2],[x,y]);
	if nops(sol)=0 then  error("Solve: Keine Lsung!"); end_if;
	xx:=subs(x,sol[1]); yy:=subs(y,sol[1]); 
    i:=2;
	while i<=nops(sol) do
    	xt:=subs(x,sol[i]); yt:=subs(y,sol[i]);
 	    if Im(xt)=0.0 and Im(yt)=0.0 then
 	      if not(Im(xx)=0.0 and Im(yy)=0.0) then xx:=xt; yy:=yt; 
	      elif abs((xt-FXIntersectionHint[1])^2+(yt-FXIntersectionHint[2])^2) <
 	         abs((xx-FXIntersectionHint[1])^2+(yy-FXIntersectionHint[2])^2)
		  then xx:=xt; yy:=yt;
		  end_if;
		end_if;
		i:=i+1;
	end_while;
	end_if; // Ende Algo-Alternative
	p:=addPoint(na,xx,yy);
    addEquationIntersection(na,a,b);
	m
end_proc:

addLine2P0:= (a,b) -> addLine2P(newname("L"),a,b):
addLine2P:=proc(na:DOM_STRING,a:DOM_STRING,b:DOM_STRING)
  local g,aa,bb,cc,x1,y1,x2,y2,n0;
begin  
	if bool(getType(a)<>"point" or getType(b)<>"point") then error("Punkt ntig!"); end_if;
	if a=b  then error("Punkte mssen verschieden sein!"); end_if;
	x1:=getVar(xc[a]);y1:=getVar(yc[a]); x2:=getVar(xc[b]); y2:=getVar(yc[b]);
    n0:=[y1-y2,x2-x1]; 
	if abs(float(norm2d(n0)))<numeps then error("Punkte (fast) identisch!"); end_if;
	n0:=[n0[1]/norm2d(n0),n0[2]/norm2d(n0)];
	[aa,bb]:=float(n0); cc:=float(n0[1]*x1+n0[2]*y1);
	g:=addLine(na,aa,bb,cc);
    addEquationPointOn(a,g);
    addEquationPointOn(b,g);
	g
end_proc:

addVector2P0:= (a,b) -> addVector2P(newname("V"),a,b):
addVector2P:=proc(na:DOM_STRING,a:DOM_STRING,b:DOM_STRING)
  local g,x1,y1,x2,y2;
begin  
	if bool(getType(a)<>"point" or getType(b)<>"point") then error("Punkt ntig!"); end_if;
	if a=b  then error("Punkte mssen verschieden sein!"); end_if;
	x1:=getVar(xc[a]);y1:=getVar(yc[a]); x2:=getVar(xc[b]); y2:=getVar(yc[b]);
  	g:=addVector(na,x1,y1,x2-x1,y2-y1);
	addEquationComment(xc[g]=xc[a],"x Anfang ".g." = ".a);
	addEquationComment(yc[g]=yc[a],"y Anfang ".g." = ".a);
	addEquationComment(vx[g]=xc[b]-xc[a],"x Ende ".g." = ".b);
	addEquationComment(vy[g]=yc[b]-yc[a],"y Ende ".g." = ".b);
	g
end_proc:

addSegment2P0:= (a,b) -> addSegment2P(newname("S"),a,b):
addSegment2P:=proc(na:DOM_STRING,a:DOM_STRING,b:DOM_STRING)
  local g,x1,y1,x2,y2;
begin  
	if a=b  then error("Punkte mssen verschieden sein!"); end_if;
	if bool(getType(a)<>"point" or getType(b)<>"point") then error("Punkt ntig!"); end_if;
	x1:=getVar(xc[a]);y1:=getVar(yc[a]); x2:=getVar(xc[b]); y2:=getVar(yc[b]);
  	g:=addVector(na,x1,y1,x2-x1,y2-y1);
	addEquationComment(xc[g]=xc[a],"x Anfang ".g." = ".a);
	addEquationComment(yc[g]=yc[a],"y Anfang ".g." = ".a);
	addEquationComment(vx[g]=xc[b]-xc[a],"x Ende ".g." = ".b);
	addEquationComment(vy[g]=yc[b]-yc[a],"y Ende ".g." = ".b);
	if FXallowJava then java::DGSFelix::setVectorSegment(felixHandle,g,TRUE); end_if;
	g
end_proc:



addOrthogonal0:=(p,obj) -> addOrthogonal(newname("L"),p,obj):
addOrthogonal:=proc(na:DOM_STRING,p:DOM_STRING,obj:DOM_STRING)
  local e1,e2,eqs,g,sol;
  save a0,b0,c0;
begin  
	delete a0,b0,c0;
	if getType(p)<>"point"  then error("Punkt ntig!"); end_if;
	g:=addLine(na,1,2,3);
    e1:=addEquationOrthogonal(g,obj);     
    e2:=addEquationPointOn(p,g);
	eqs:=[e1,e2,ac[g]^2+bc[g]^2=1];
	eqs:=insertValues(subs(eqs,ac[g]=a0,bc[g]=b0,cc[g]=c0));  
	sol:=numeric::fsolve(eqs,[a0,b0,c0]);
	[a0,b0,c0]:= subs([a0,b0,c0],sol);
	setVar(ac[g],float(a0));setVar(bc[g],float(b0));setVar(cc[g],float(c0));
	FelixRepaint();
    g
end_proc:




addBisector0:=(l1,l2) -> addBisector(newname("L"),l1,l2):
addBisector:=proc(na:DOM_STRING,l1:DOM_STRING,l2:DOM_STRING)
  local eq,a,b,c,L1,L2,N1,N2,N; save C3,B3,A3;
begin  
delete A3,B3,C3;
	if not((getType(l1)="vector" or getType(l1)="line") and (getType(l2)="vector" or getType(l2)="line")) 
	   then error("Geraden/Vektoren noetig!"); end_if;
    if getType(l1)="line" then L1:=[ac[l1],bc[l1],cc[l1]]
	else L1:=[-vy[l1],vx[l1],-vy[l1]*xc[l1]+vx[l1]*yc[l1]]; end_if;
    if getType(l2)="line" then L2:=[ac[l2],bc[l2],cc[l2]]
	else L2:=[-vy[l2],vx[l2],-vy[l2]*xc[l2]+vx[l2]*yc[l2]]; end_if;
    N1:=sqrt(L1[1]^2+L1[2]^2); N2:=sqrt(L2[1]^2+L2[2]^2);
    N:=[(L1[1]*N2+L2[1]*N1)/2,(L1[2]*N2+L2[2]*N1)/2]; /* symbolischer Normalenvektor der WH */
    [a,b]:=float(insertValues(N));  /* numerisch */
    /* eq=0 bedeutet Kopunktualitt. */
    eq:=L1[1]*L2[2]*C3 - L1[1]*B3*L2[3] - L2[1]*L1[2]*C3 + L2[1]*B3*L1[3] + A3*L1[2]*L2[3] - A3*L2[2]*L1[3];
    eq:=subs(eq,A3=ac[na],B3=bc[na]); 
    sol:=subs( ( - L1[1]*B3*L2[3]  + L2[1]*B3*L1[3] + A3*L1[2]*L2[3] - A3*L2[2]*L1[3])/(-L1[1]*L2[2]+L2[1]*L1[2]) ,
              A3=ac[na],B3=bc[na]);
    addEquationComment(subs(eq,C3=cc[na])=0,"WH: Kopunkt.");
    addEquationComment(bc[na]*N[1]=N[2]*ac[na],"");     
    c:=subs(insertValues(sol),ac[na]=a,bc[na]=b);  
	g:=addLine(na,a,b,c);	
    setVar(ac[g],float(a));setVar(bc[g],float(b));setVar(cc[g],float(c));
	FelixRepaint();
    g
end_proc:

addBisector20:=(l1,l2) -> addBisector2(newname("L"),l1,l2):
addBisector2:=proc(na:DOM_STRING,l1:DOM_STRING,l2:DOM_STRING)
  local eq,a,b,c,L1,L2,N1,N2,N; save C3,B3,A3;
begin  
delete A3,B3,C3;
    if not((getType(l1)="vector" or getType(l1)="line") and (getType(l2)="vector" or getType(l2)="line")) 
	   then error("Geraden/Vektoren noetig!"); end_if;
    if getType(l1)="line" then L1:=[ac[l1],bc[l1],cc[l1]]
	else L1:=[-vy[l1],vx[l1],-vy[l1]*xc[l1]+vx[l1]*yc[l1]]; end_if;
    if getType(l2)="line" then L2:=[ac[l2],bc[l2],cc[l2]]
	else L2:=[-vy[l2],vx[l2],-vy[l2]*xc[l2]+vx[l2]*yc[l2]]; end_if;
    N1:=sqrt(L1[1]^2+L1[2]^2); N2:=sqrt(L2[1]^2+L2[2]^2);
    N:=[(L1[1]*N2-L2[1]*N1)/2,(L1[2]*N2-L2[2]*N1)/2]; /* symbolischer Normalenvektor der WH */
    [a,b]:=float(insertValues(N));  /* numerisch */
    /* eq=0 bedeutet Kopunktualitt. */
    eq:=L1[1]*L2[2]*C3 - L1[1]*B3*L2[3] - L2[1]*L1[2]*C3 + L2[1]*B3*L1[3] + A3*L1[2]*L2[3] - A3*L2[2]*L1[3];
    eq:=subs(eq,A3=ac[na],B3=bc[na]); 
    sol:=subs( ( - L1[1]*B3*L2[3]  + L2[1]*B3*L1[3] + A3*L1[2]*L2[3] - A3*L2[2]*L1[3])/(-L1[1]*L2[2]+L2[1]*L1[2]) ,
              A3=ac[na],B3=bc[na]);
    addEquationComment(subs(eq,C3=cc[na])=0,"WH: Kopunkt.");
    addEquationComment(bc[na]*N[1]=N[2]*ac[na],"");     
    c:=subs(insertValues(sol),ac[na]=a,bc[na]=b);  
	g:=addLine(na,a,b,c);	
    setVar(ac[g],float(a));setVar(bc[g],float(b));setVar(cc[g],float(c));
	FelixRepaint();
    g
end_proc:



addParallel0:=(p,obj) -> addParallel(newname("L"),p,obj):
addParallel:=proc(na:DOM_STRING,p:DOM_STRING,obj:DOM_STRING)
  local e1,e2,eqs,g,sol;
  save a0,b0,c0;
begin  
	delete a0,b0,c0;
	if getType(p)<>"point"  then
        if getType(obj)="point" then return(addParallel(na,obj,p)); 
	    else error("Punkt ntig!"); end_if;
	end_if;
	g:=addLine(na,1,2,3);
    e1:=addEquationParallel(g,obj);     
    e2:=addEquationPointOn(p,g);
	eqs:=[e1,e2,ac[g]^2+bc[g]^2=1];
	eqs:=insertValues(subs(eqs,ac[g]=a0,bc[g]=b0,cc[g]=c0));  
	sol:=numeric::fsolve(eqs,[a0,b0,c0]);
	[a0,b0,c0]:= subs([a0,b0,c0],sol);
	setVar(ac[g],float(a0));setVar(bc[g],float(b0));setVar(cc[g],float(c0));
	FelixRepaint();
    g
end_proc:


addCircleMP0:= (m,p) -> addCircleMP(newname("C"),m,p):
addCircleMP:=proc(na:DOM_STRING,m:DOM_STRING,p:DOM_STRING)
  local k,x1,y1,x2,y2;
begin  
	if getType(m)<>"point" or getType(p)<>"point" then error("Punkte ntig!"); end_if;
	if m=p  then error("Punkte mssen verschieden sein!"); end_if;
	x1:=getVar(xc[m]);y1:=getVar(yc[m]); x2:=getVar(xc[p]); y2:=getVar(yc[p]);
    k:=addCircle(na,float(x1),float(y1),float(sqrt((x2-x1)^2+(y2-y1)^2)));
    addEquationPointOn(p,k); 
	addEquationComment(xc[na]=xc[m],na."=K(".m.",".p.")");
	addEquationComment(yc[na]=yc[m],na."=K(".m.",".p.")");
	k
end_proc:

addCircleMR0:= (m,pr) -> addCircleMR(newname("C"),m,r):
addCircleMR:=proc(na:DOM_STRING,m:DOM_STRING,r)
  local k,x1,y1;
begin  
	if getType(m)<>"point"  then error("Punkte ntig!"); end_if;
	x1:=getVar(xc[m]); y1:=getVar(yc[m]); 
    k:=addCircle(na,x1,y1,float(r));
    addEquationComment(xc[na]=xc[m],na."=K(".m.",".expr2text(r).")");
    addEquationComment(yc[na]=yc[m],na."=K(".m.",".expr2text(r).")");
    addEquationComment(rc[na]=r,na."=K(".m.",".expr2text(r).")");
	k
end_proc:

addLR:=proc()
local na,pts,i;
begin
  if args(0)=0 then error("Zuwenig Argumente!");
  elif args(0)=1 then pts:=args(1); na:= newname("L");
  else pts:=args(2); na:=args(1); end_if;
  if not(domtype(na)=DOM_STRING) then na:=expr2text(na); end_if;
  if not(domtype(pts)=DOM_LIST) then error("Zweits Argument muss Liste sein."); end_if; 
  addLine(na,1,2,3);
  addEquationLR(na,pts);
  setVar(ac[na],insertValues(ac[na]));
  setVar(bc[na],insertValues(bc[na]));
  setVar(cc[na],insertValues(cc[na]));
  RelaxDonlpR();
end_proc:

// Eigenschaften hinzufgen

addEquationPointOn:=proc(oname:DOM_STRING,traeger:DOM_STRING)
local  typ,eq ;
begin
	typ:=getType(traeger);
	if typ=null() then error("Objekt ohne Typ"); end_if;
	if typ="point" then eq:= [xc[oname]=xc[traeger],yc[oname]=yc[traeger]];
        elif typ="line" then eq:= xc[oname]*ac[traeger]+yc[oname]*bc[traeger]=cc[traeger];
        elif typ="vector" then 
	    eq:=addInEquationPointOnSegment(oname,traeger);
	    addComment(eq[1],oname." innerhalb ".trager);addComment(eq[2],oname." innerhalb ".trager);
	    eq:= -xc[oname]*vy[traeger]+yc[oname]*vx[traeger]=-xc[traeger]*vy[traeger]+yc[traeger]*vx[traeger];
	elif typ="circle" then eq:= rc[traeger]^2=(xc[oname]-xc[traeger])^2+(yc[oname]-yc[traeger])^2;
	elif typ="FuncCurve" then eq:= getEquationOf(traeger,xc[oname],yc[oname]);
	elif typ="ParaCurve" then eq:= getEquationOf(traeger,xc[oname],yc[oname]);
	elif typ="ImplCurve" then eq:= getEquationOf(traeger,xc[oname],yc[oname]);
	else error("Trger ".typ." wird noch nicht erkannt!"); 
	end_if;
	addEquation(eq); addComment(eq,oname." auf ".traeger);
	eq
end_proc:

PSlinks:=proc(x,y,x0,y0,vx,vy)
local g; 
begin
g:=(xx,yy)->vx*(xx-x0)+vy*(yy-y0);
g(x,y)>0
end_proc:
PSrechts:=proc(x,y,x0,y0,vx,vy)
local g; 
begin
g:=(xx,yy)->vx*(xx-(x0+vx))+vy*(yy-(y0+vy));
g(x,y)<0
end_proc:

addInEquationPointOnSegment:=proc(P:DOM_STRING, S:DOM_STRING)
begin
[addEquation(PSlinks(xc[P],yc[P],xc[S],yc[S],vx[S],vy[S])),
addEquation(PSrechts(xc[P],yc[P],xc[S],yc[S],vx[S],vy[S]))]
end_proc:


glueTo:=proc(oname:DOM_STRING,traeger:DOM_STRING)
begin
  if getType(oname)<>"point" then error("Punkt notwendig!"); end_if;
  if addEquationPointOn(oname,traeger)=FAIL then error("Gleichung nicht gefunden!"); end_if;
  projectPointTo(oname,traeger);
  RelaxDonlpR()
end_proc:


addEquationIntersection:=proc(m:DOM_STRING,a:DOM_STRING,b:DOM_STRING)
begin
	[addEquationPointOn(m,a),addEquationPointOn(m,b)]
end_proc:

addEquationTangentFlex:=proc(a:DOM_STRING,b:DOM_STRING,c:DOM_STRING)
begin
  if getType(a)="point" then addEquationTangent(b,a,c)
  elif getType(b)="point" then addEquationTangent(a,b,c)
  elif getType(c)="point" then addEquationTangent(a,c,b)
  else error("Kein Punkt!");
  end_if
end_proc:

addEquationTangent:=proc(a:DOM_STRING,p:DOM_STRING,b:DOM_STRING)
  // a,b sind in p tangential, p muss punkt sein
  // es wird angenommen, dass p auf a und b liegt 
local tv,tu,e,term,abl,sol;
save x,y;
begin
  delete x,y;
  if not(getType(p)="point") then return(FAIL); end_if;
  if getType(a)="line" and getType(b)="line" then 
    e:=addEquation(ac[a]*bc[b]=ac[b]*bc[a]); addComment(e,a." tang an ".b." in ".p); 
	return(e); 
  end_if;
  if getType(a)="vector" and getType(b)="vector" then 
    e:=addEquation(vx[a]*vy[b]=vx[b]*vy[a]); addComment(e,a." tang an ".b." in ".p); 
	return(e); 
  end_if;
  if getType(a)="line" and getType(b)="vector" then 
    e:=addEquation(ac[a]*vx[b]+bc[a]*vy[b]=0); addComment(e,a." tang an ".b." in ".p); 
	return(e); 
  end_if;
  if getType(a)="vector" and getType(b)="line" then 
    e:=addEquation(ac[b]*vx[a]+bc[b]*vy[a]=0); addComment(e,a." tang an ".b." in ".p); 
	return(e); 
  end_if;
  if getType(b)="line" then return(addEquationTangent(b,p,a)); end_if;
  if getType(b)="vector" then return(addEquationTangent(b,p,a)); end_if;
  if getType(a)="line" then
     tv:=getTangentVectorTerm(b,p);
	 if tv=FAIL then return(FAIL); end_if;
     e:=addEquation(ac[a]*tv[1]+bc[a]*tv[2]=0); addComment(e,a." tang an ".b." in ".p); 
  end_if; /* a Gerade */
  if getType(a)="vector" then
     tv:=getNormalVectorTerm(b,p);
	 if tv=FAIL then return(FAIL); end_if;
     e:=addEquation(vx[a]*tv[1]+vy[a]*tv[2]=0); addComment(e,a." tang an ".b." in ".p); 
  end_if; /* a Gerade */
     tu:=getNormalVectorTerm(a,p);
     tv:=getNormalVectorTerm(b,p);
     if tv=FAIL or tu=FAIL then return(FAIL); end_if;
     e:=addEquation(tu[2]*tv[1]-tu[1]*tv[2]=0); addComment(e,a." tang an ".b." in ".p); 
end_proc:

addEquationNormalFlex:=proc(a:DOM_STRING,b:DOM_STRING,c:DOM_STRING)
begin
  if getType(a)="point" then addEquationNormal(b,a,c)
  elif getType(b)="point" then addEquationNormal(a,b,c)
  elif getType(c)="point" then addEquationNormal(a,c,b)
  else error("Kein Punkt!");
  end_if
end_proc:

addEquationNormal:=proc(a:DOM_STRING,p:DOM_STRING,b:DOM_STRING)
  // a,b sind in p normal, p muss punkt sein
  // es wird angenommen, dass p auf a und b liegt 
local tv,e,term,abl,sol;
save x,y;
begin
  delete x,y;
  if not(getType(p)="point") then return(FAIL); end_if;
  if getType(a)="line" and getType(b)="line" then 
    e:=addEquation(ac[a]*ac[b]+bc[b]*bc[a]=0); addComment(e,a." normal an ".b." in ".p); 
	return(e); 
  end_if;
  if getType(a)="vector" and getType(b)="vector" then 
    e:=addEquation(0=vx[a]*vx[b]+vy[b]*vy[a]); addComment(e,a." normal an ".b." in ".p); 
	return(e); 
  end_if;
  if getType(a)="line" and getType(b)="vector" then 
    e:=addEquation(ac[a]*vy[b]=bc[a]*vx[b]); addComment(e,a." normal an ".b." in ".p); 
	return(e); 
  end_if;
  if getType(a)="vector" and getType(b)="line" then 
    e:=addEquation(ac[b]*vy[a]=bc[b]*vx[a]); addComment(e,a." normal an ".b." in ".p); 
	return(e); 
  end_if;
  if getType(b)="line" then return(addEquationNormal(b,p,a)); end_if;
  if getType(b)="vector" then return(addEquationNormal(b,p,a)); end_if;
  if getType(a)="line" then
     tv:=getNormalVectorTerm(b,p);
	 if tv=FAIL then return(FAIL); end_if;
     e:=addEquation(ac[a]*tv[1]+bc[a]*tv[2]=0); addComment(e,a." normal an ".b." in ".p); 
  end_if; /* a Gerade */
  if getType(a)="vector" then
     tv:=getTangentVectorTerm(b,p);
	 if tv=FAIL then return(FAIL); end_if;
     e:=addEquation(vx[a]*tv[1]+vy[a]*tv[2]=0); addComment(e,a." normal an ".b." in ".p); 
  end_if; /* a Gerade */
     tu:=getNormalVectorTerm(a,p);
     tv:=getNormalVectorTerm(b,p);
     if tv=FAIL or tu=FAIL then return(FAIL); end_if;
     e:=addEquation(tu[1]*tv[1]+tu[2]*tv[2]=0); addComment(e,a." normal an ".b." in ".p); 
end_proc:

addEquationOrthogonal:=proc(g,obj)
local e,a,b,a1,b1;
begin
	if getType(g)="line" then
	  a:=ac[g]; b:=bc[g];   
	  if getType(obj)="line" then 
    	  a1:=ac[obj]; b1:=bc[obj];   
	  elif getType(obj)="vector" then
	      a1:=-vy[obj]; b1:=vx[obj];
	  else error("Unbekannter Typ: ".getType(obj));
	  end_if;
	  e:=addEquation(a*a1+b*b1=0);
	  addComment(e,g." ortho ".obj);
	  return(e);
	end_if;
	if getType(g)="vector" then
	  b:=-vx[g]; a:=vy[g];   
	  if getType(obj)="line" then 
    	  a1:=ac[obj]; b1:=bc[obj];   
	  elif getType(obj)="vector" then
	      a1:=-vy[obj]; b1:=vx[obj];
	  else error("Unbekannter Typ: ".getType(obj));
	  end_if;
	  e:=addEquation(a*a1+b*b1=0);
	  addComment(e,g." ortho ".obj);
	  return(e);
	end_if;
end_proc:

addEquationParallel:=proc(g,obj)
local e,a,b,a1,b1;
begin
	if getType(g)="line" then
	  a:=ac[g]; b:=bc[g];   
	  if getType(obj)="line" then 
    	  a1:=ac[obj]; b1:=bc[obj]; 
  	  elif getType(obj)="vector" then
	      a1:=-vy[obj]; b1:=vx[obj];
	  else error("Unbekannter Typ: ".getType(obj));
	  end_if;
	  e:=addEquation(a*b1-b*a1=0); addComment(e,g." parallel ".obj);
	  return(e);
	end_if;
	if getType(g)="vector" then
	  a:=-vy[g]; b:=vx[g];   
	  if getType(obj)="line" then 
    	  a1:=ac[obj]; b1:=bc[obj]; 
  	  elif getType(obj)="vector" then
	      a1:=-vy[obj]; b1:=vx[obj];
	  else error("Unbekannter Typ: ".getType(obj));
	  end_if;
	  e:=addEquation(a*b1-b*a1=0); 
	  addComment(e,g." parallel ".obj);
	  return(e);
	end_if;
end_proc:


addEquationMidPoint:=proc(m:DOM_STRING,a:DOM_STRING,b:DOM_STRING)
local eq;
begin
	if getType(m)<>"point" or getType(a)<>"point" or getType(b)<>"point" then error("Punkt ntig!"); end_if;
	eq:=[2*xc[m]=xc[a]+xc[b],2*yc[m]=yc[a]+yc[b]];
	addEquationComment(eq[1],"x ".m."=MP(".a.",".b.")");
	addEquationComment(eq[2],"y ".m."=MP(".a.",".b.")");
	eq
end_proc:



addEquationLR:=proc(L:DOM_STRING,pts:DOM_LIST)
local X,Y,XY,X2,Y2,xl,yl,i,mm,bb,n  ;
begin
  n:=nops(pts);
  xl:=map(pts,a->xc[a]); yl:=map(pts,a->yc[a]); 
  XY:=0; Y:=0; X:=0; X2:=0; Y2:=0;
  for i from 1 to n do 
    XY:=XY+xl[i]*yl[i];
    X:=X+xl[i];
    Y:=Y+yl[i];
    Y2:=Y2+yl[i]^2;
    X2:=X2+xl[i]^2;
  end_for;
  mm:=(XY-1/n*Y*X)/(X2-1/n*X*X);
  bb:=(X2*Y-XY*X)/(n*X2-X^2);
  addEquation(ac[L]=-mm*bc[L]);
  addEquation(cc[L]=bb*bc[L]);
  L  
 end_proc:


// Differentialrelationen

getNormalVectorTerm:=proc(obj,P) /* P is assumed to be point on obj */
local typ,l;
begin
typ:=getType(obj);
if 	typ="circle" then return([xc[P]-xc[obj],yc[P]-yc[obj]]);
elif typ="line" then return([ac[obj],bc[obj]]);
elif typ="FuncCurve" then return(subs([diff(getCurveOp(obj,1),getCurveOp(obj,2)),-1],
                            getCurveOp(obj,2)=xc[P]));
elif typ="ImplCurve" then 
   return(subs([diff(eq2term(getCurveOp(obj,1)),getCurveOp(obj,2)),
diff(eq2term(getCurveOp(obj,1)),getCurveOp(obj,3))],
  getCurveOp(obj,2)=xc[P],getCurveOp(obj,3)=yc[P]));
elif typ="ParaCurve" then l:=getCurveOps(obj);
if nops(l)=8 then return(subs([diff(eq2term(l[8]),PIx),diff(eq2term(l[8]),PIy)],
  PIx=xc[P],PIy=yc[P]))
  else return(FAIL);
end_if;  
else return(FAIL);
end_if;
end_proc:


getTangentVectorTerm:=proc(obj,P) /* P is assumed to be point on obj */
local typ,l,rot90;
begin
rot90:= p-> [p[2],-p[1]];
typ:=getType(obj);
if 	typ="circle" then return([yc[P]-yc[obj],-xc[P]+xc[obj]]);
elif typ="line" then return([bc[obj],-ac[obj]]);
elif typ="FuncCurve" then return(subs([1,diff(getCurveOp(obj,1),getCurveOp(obj,2))],
                            getCurveOp(obj,2)=xc[P]));
elif typ="ImplCurve" then 
   return(rot90(subs([diff(eq2term(getCurveOp(obj,1)),getCurveOp(obj,2)),
diff(eq2term(getCurveOp(obj,1)),getCurveOp(obj,3))],
  getCurveOp(obj,2)=xc[P],getCurveOp(obj,3)=yc[P])));
elif typ="ParaCurve" then l:=getCurveOps(obj);
if nops(l)=8 then return(subs([diff(eq2term(l[8]),PIy),-diff(eq2term(l[8]),PIx)],
  PIx=xc[P],PIy=yc[P]))
  else return(FAIL);
end_if;  
else return(FAIL);
end_if;
end_proc:


// Eigenschaften

angleOfLine:=proc(obj) // alte Version
local a,b,vw,d;
begin
	if not(domtype(obj)=DOM_STRING) then error("Objektname (String) ntig!"); end_if;
	if not(getType(obj)="line") then error("Objekt muss Linie sein!"); end_if;
	a:=float(getVar(ac[obj])); b:=float(getVar(bc[obj]));
    if a<0 then a:=-a; b:=-b; d:=PI; else d:=0.0; end_if;
	// vw ist Winkel des Normalenvektors
	if a>abs(b) then vw:=arctan(b/a) else  
     if b>0 then vw:=PI/2-arctan(float(a/b)); else vw:=-PI/2+arctan(float(-a/b)); end_if; end_if;
    float(vw+d-PI/2)
end_proc:

angleOfLine:=proc(obj) // Neue Version
local angle,a,b;
begin
	if not(domtype(obj)=DOM_STRING) then error("Objektname (String) ntig!"); end_if;
	if not(getType(obj)="line") then error("Objekt muss Linie sein!"); end_if;
	a:=float(getVar(ac[obj])); b:=float(getVar(bc[obj]));
if abs(b)>abs(a) then angle:=arctan(a/b); 
if a<=0 and b<0 then angle:=angle+float(PI); 
elif a<=0 and b>0  then angle:=angle+float(2*PI    ); 
elif a>=0 and b<0  then angle:=angle+float(PI); end_if;
else angle:=float(PI/2-arctan(b/a)); 
if a<0 and b<=0 then angle:=angle+float(PI); 
elif a<0 and b>=0  then angle:=angle+float(PI); 
elif a>0 and b<=0  then angle:=angle+float(0); end_if;
end_if;
if angle>=float(PI) then angle:=angle-float(2*PI); end_if;
if angle<=-float(PI) then angle:=angle+float(2*PI); end_if;
angle
end_proc:


// Utilities ----------------------------------------------------


toStr:=proc(x) begin if testtype(x,DOM_STRING) then x else expr2text(x) end_if end_proc:

toStrC:=proc(x) 
local p,s,i;
begin 
if testtype(x,DOM_STRING) then x else 
	s:=generate::C(x); 
  i:=1;
  while i<=length(s) do
     if s[i]="=" then break; end_if;
     i:=i+1;
  end_while;
	s[(i+1)..(length(s)-1)]
end_if
end_proc:

//----- Java-Code-Erzeugung 
operator("xxx",Delete):operator("xxx",_unsimplified_product,Binary,1000):
GenJavaStr:=proc (term)
begin
//stringlib::subs(expr2text(GenJava(term)),"Math_"="Math.","xxx"="*")
stringlib::subs(expr2text(GenJava(term)),"Math_"="","xxx"="*")
end_proc:
GenJava:=proc(term) 
save x;
begin
delete x; 
if atomicTypeQ(term) then term
elif op(term,0)=op(x^2,0) then  
  if op(term,2)=2 then GenJava(op(term,1)) xxx GenJava(op(term,1)) 
  elif op(term,2)=1/2 then Math_sqrt(GenJava(op(term,1)))
  else Math_pow(GenJava(op(term,1)),GenJava(op(term,2)))
  end_if
elif op(term,0)=op(sin(x),0) then Math_sin(GenJava(op(term,1)))
elif op(term,0)=op(cos(x),0) then Math_cos(GenJava(op(term,1)))
elif op(term,0)=op(tan(x),0) then Math_tan(GenJava(op(term,1)))
elif op(term,0)=op(exp(x),0) then Math_exp(GenJava(op(term,1)))
elif op(term,0)=op(ln(x),0) then Math_log(GenJava(op(term,1)))
else map(term,GenJava)
end_if
end_proc:
//----------------  


isFelixVar:=proc(x)
begin
  if atomicTypeQ(x) then return(FALSE); end_if;
  if bool(has(FelixVarHeads,op(x,1)) and domtype(op(x,2))=DOM_STRING) then return(TRUE); end_if;
  FALSE
end_proc:

isBasicVar:= v -> if not(isFelixVar(v)) then FALSE else isBasicObj(op(v,2)) end_if:  

headtype:= v-> if type(v)="_index" then op(v,1) else v end_if:

objectsInvolved:= proc(aa)
	local a,res,gorecursive;
	begin
	gorecursive:=proc(a) 
		local i;
		begin 
		if atomicTypeQ(a) then return(); end_if;
		if nops(a)=2 then
		  if testtype(a,"_index") and has(FelixVarHeads,op(a,1)) then
			res:={op(res),op(a,2)};
		  else 
		    gorecursive(op(a,1)); gorecursive(op(a,2)); return();
		  end_if;
		end_if;
		for i from 1 to nops(a) do gorecursive(op(a,i)); end_for; 
		end_proc:
	res:={};
	if (domtype(aa)=DOM_STRING) then a:=text2expr(aa) else a:=aa; end_if;
	gorecursive(a);
        return(res);
end_proc:


varsInvolved:= proc(aa)
	local a,res,gorecursive;
	begin
	gorecursive:=proc(a) 
		local i;
		begin
		if atomicTypeQ(a) then return(); end_if;
		if nops(a)=2 then
		  if testtype(a,"_index") and has(FelixVarHeads,op(a,1)) then
			res:={op(res),a};
		  else 
		    gorecursive(op(a,1)); gorecursive(op(a,2));return();
		  end_if;
		end_if;
		for i from 1 to nops(a) do gorecursive(op(a,i)); end_for; 
		end_proc:
	res:={};
	if (domtype(aa)=DOM_STRING) then a:=text2expr(aa) else a:=aa; end_if;
	gorecursive(a);
        return(res);
end_proc:

checkVars:= proc(ex) // Enthlt ex nur bekannte Felix-variablen?  
					// checkvars(ex,{x1,x2.. }) erluabt weitere variablen!  
				local vi,a,i;
begin
    a:=[args()]; ex:=float(ex);
    if nops(a)=2 then a:={op(a[2])}; else a:={} end_if;
    vi:=varsInvolved(ex); 
    for i from 1 to nops(vi) do 
	  if (not has(Config,vi[i])) and not(vi[i]=PI) then return(FALSE); end_if; 
    end_for;
    bool(nops(indets(ex) minus ({op(FelixVarHeads)} union a))=0)
end_proc:

FelixFuncs:=["sin","cos","tan","arcsin","arccos","arctan","exp","ln","log","abs","sign","sinh","cosh","tanh","angle0","len"]:
FelixFuncs2:=["_plus","_mult","_power","_equal","_less","_leequal","angle","dist","dist2"]:
checkFuncs:=proc(a)
local i;
begin
if type(a)="_index" then  return(has(Config,a)); 
elif atomicTypeQ(a) then TRUE
elif nops(a)=1 and has(FelixFuncs,type(a)) then checkFuncs(op(a,1))
elif nops(a)>=2 and has(FelixFuncs2,type(a)) then 
for i from 1 to nops(a) do if not(checkFuncs(op(a,i))) then return(FALSE); end_if;
  end_for;
  return(TRUE);
elif domtype(a)=DOM_LIST or domtype(a)=DOM_SET then
  for i from 1 to nops(a) do if not(checkFuncs(op(a,i))) then return(FALSE); end_if;
  end_for;
  return(TRUE);
else return(FALSE)
end_if
end_proc:


atomicTypeQ:=proc(x) begin
  bool(domtype(x)=DOM_INT  or domtype(x)=DOM_COMPLEX or domtype(x)=DOM_BOOL or 
  domtype(x)=DOM_FAIL or domtype(x)=DOM_FLOAT or domtype(x)=DOM_IDENT or 
  domtype(x)=DOM_NIL or domtype(x)=DOM_NULL or domtype(x)=DOM_RAT or 
  domtype(x)=DOM_STRING or domtype(x)=DOM_VAR)  
end_proc:


sqrt2SQRT:=proc(a)
begin
if atomicTypeQ(a) then a 
elif op(a,0)=op(2^(1/2),0) then  
  if op(a,2)=1/2 then SQRT(sqrt2SQRT(op(a,1)))
  else sqrt2SQRT(op(a,1))^sqrt2SQRT(op(a,2))
  end_if
else map(a,sqrt2SQRT)
end_if
end_proc:

traverseSubsString:=proc(a,alt:DOM_STRING,neu:DOM_STRING)
begin
if domtype(a)=DOM_STRING then stringlib::subs(a,alt=neu)
elif atomicTypeQ(a) then a else map(a,traverseSubsString,alt,neu) end_if
end_proc:

ieq2term:=proc(ieq) begin 
    if type(ieq)="_less" or type(ieq)="_leequal" then  op(ieq,2)-op(ieq,1) else ieq end_if
end_proc:


DiffTot:=proc(term,vars:DOM_SET)
local i,s,a,b;
begin
if has(vars,term) then dt(term) 
elif atomicTypeQ(term) or type(term)="_index" then 0 
elif type(term)="_plus" or type(term)="_equal" then map(term,DiffTot,vars)
elif type(term)="_mult" then 
   s:=0; for i from 1 to nops(term) do s:=s+term/op(term,i)*DiffTot(op(term,i),vars); end_for;
   return(s);
elif type(term)="_power" then a:=op(term,1); b:=op(term,2); 
   return(a^(b-1)*b*DiffTot(a,vars)+a^b*ln(a)*DiffTot(b,vars));
elif type(term)="sin" then return(cos(op(term,1))*DiffTot(op(term,1),vars));
elif type(term)="cos" then return(-sin(op(term,1))*DiffTot(op(term,1),vars));
else DIFFTOT(term,vars)
end_if;  
end_proc:

/* Felix-Java conversion ----------------------------------------------------------*/

preprocess:=proc(expr) 
local s,p;
begin
  s:=generate::C(expr); 
  p:=strmatch(s,"=",Index); 
  if not(p=FALSE) then p:=p[1]; s:=substring(s,p+1..length(s)-1);  
  else s:=substring(s,1..length(s)-1);end_if;
  stringlib::subs(s,"\"\""="\"");
end_proc:


/* MINIMIZE DONLP strategy --------------------------------------------------------*/

FXAA:=[]:
FXStack:=adt::Stack():

FXuseLP:=TRUE:
FXLPsubs:=[]:

FXzielFaktor:=50.0: // Gewichtung des Ziels
FXRandomR:=0.0:

normalizeLines0:=proc() // Normiert geradengleichungen auf a^2+b^2=1
local i,ob,a,b,c,n;
begin
	for i from 1 to nops(Objects) do
		if Objects[i][2]="line" then 
			ob:=Objects[i][1];
			a:=getVar(ac[ob]);b:=getVar(bc[ob]);c:=getVar(cc[ob]);
			n:=sqrt(a^2+b^2);
			a:=a/n; b:=b/n; c:=c/n;
			setVar0(ac[ob],a); setVar0(bc[ob],b); setVar0(cc[ob],c);
		end_if;
    end_for;
end_proc:

FXclearDenom:=TRUE:

FXuseSPH:=FALSE: // Punkte werden auf Kugel projeziert, setzt voraus, dass in Config erst xc dann yc
FXSPH:=[]:

FXcorr:=FALSE: // Ist wahr wenn Kreise, Strecken bewegt werden, dann muss distanz bercksichtigt werden
FXoffset:=[0,0]: // FXcorr und FXoffset werden vom GUI gesetzt. 

FXExtraIEdist:=0.01: // Additional space in inequalities


posinList:=proc(x,L:DOM_LIST)  // Pos oder 0 falls nicht vorkommt
local i,n;
begin n:=nops(L);
  for i from 1 to n do
    if L[n+1-i]=x then return(n+1-i); end_if;
  end_for;
  return(0);
end_proc:



prepareMoveDonlp:=proc(obj:DOM_STRING) 
local restvars,restvals,objprocessed,sphc,posxc,posyc,vars0,bo,i,j,eqs,ieqs,vars,ivals,v;
save xziel,yziel;
begin 
  FXSPH:=[];
  if getType(obj)<>"point" and getType(obj)<>"circle" and getType(obj)<>"vector" then 
     error("Nur Punkte, Strecken, Vektoren und Kreise direkt ziehbar!"); end_if;
  if getType(obj)="circle" then 
     FXcorr:=TRUE; FXoffset:=[getVar(xc[obj])-FXLastDown[1],getVar(yc[obj])-FXLastDown[2]];
     restvars:=[rc[obj]]; restvals:=insertValues(restvars);
  elif getType(obj)="vector" then 
     FXcorr:=TRUE; FXoffset:=[getVar(xc[obj])-FXLastDown[1],getVar(yc[obj])-FXLastDown[2]];
     restvars:=[vx[obj],vy[obj]]; restvals:=insertValues(restvars);
  
    else restvars:=[]; restvals:=[]; FXcorr:=FALSE; end_if;
  delete xziel,yziel;
  normalizeLines0();
  // eqs:=map(getEquations(),eq2term);     ??? tut nchste zeile immer gut? 
  if FXclearDenom then 
    eqs:=map(map(map(getEquations(),simpEq),clearDenom),eq2term);
  else 
    eqs:=map(map(getEquations(),simpEq),eq2term);
  end_if;
  ieqs:=map(getInEquations(),ieq2term);
  bo:=listlib::setDifference(BasicObjects,[obj]);  // Diese Koordinaten werden eingesetzt!
  // print("Einzusetzende Objekte: ",bo);
  eqs:=insertValuesOf(eqs,bo);
  ieqs:=insertValuesOf(ieqs,bo);
  normalizeLines0();
  vars:=[]; ivals:=[]; objvars:=[]; j:=0;
  for i from 1 to nops(Config) do
  	v:=op(Config[i],1);
	if op(v,2)=obj then objvars:=[objvars,v]; 
	else
	  if not(has(bo,op(v,2))) then
		if headtype(v)=ac or headtype(v)=bc then 
		  if not(has(vars,WI[op(v,2)])) then
				vars:=[op(vars),WI[op(v,2)]]; 
				ivals:=[op(ivals),angleOfLine(op(v,2))];
				eqs:=subs(eqs,  ac[op(v,2)]=sin(WI[op(v,2)]),bc[op(v,2)]=cos(WI[op(v,2)])); 
				ieqs:=subs(ieqs,ac[op(v,2)]=sin(WI[op(v,2)]),bc[op(v,2)]=cos(WI[op(v,2)])); 
		  end_if;
		else // Normalfall 
		vars:=[op(vars),v]; ivals:=[op(ivals),op(Config[i],2)];
		end_if;
		j:=j+1; 
	  end_if;
	 end_if;
  end_for;
  if FXuseLP then  // Linears prepeocessing
    vars0:=vars;
	[FXLPsubs,vars,eqs]:=LinPreSolve(eqs,vars); 
	FXLPsubs:=selfSubs(FXLPsubs);
	if FXdebug then print("Vor linsubst:",eqs); end_if;
    FXLPsubs:=selfSubs(FXLPsubs);
	eqs:=ITsubs(eqs,FXLPsubs);  // Ist das wirklich ntig?
	if FXdebug then print("Nach linsubst:",eqs); end_if;
	ieqs:=ITsubs(ieqs,FXLPsubs);
	//print("LinPSolve aufgerufen vars0=",vars0,"vars=",vars,"eliminiert=",{op(vars0)} minus {op(vars)});
	for i from 1 to nops(vars0) do if not(has(vars,vars0[i])) then ivals[i]:=xziel; end_if; end_for;
    ivals:=subs(ivals,xziel=null());
  end_if;// Ende lineares Preprocessing
  // Start Kugel
  if FXuseSPH then
    objprocessed:=[];
	for i from 1 to nops(vars) do
		v:=vars[i];
		if has(objprocessed,op(v,2)) then next; end_if;
		objprocessed:=[op(objprocessed),op(vars[i],2)];
		if not(getType(op(v,2))="point") then next; end_if;
		posxc:= posinList(xc[op(v,2)],vars);
		posyc:= posinList(yc[op(v,2)],vars);
		if posxc=0 or posyc=0 then error("FXuseSPH ".exp2text(v)); end_if;
 		FXSPH:=[op(FXSPH),[posxc,posyc]];
		sphc:=K2S([ivals[posxc],op(Config[i],2)]);
		ivals[posxc]:=sphc[1]; 
		ivals[posyc]:=sphc[2];
		eqs:=subs(eqs,  [xc[op(v,2)]=cos(xc[op(v,2)])*tan(yc[op(v,2)]),
					     yc[op(v,2)]=sin(xc[op(v,2)])*tan(yc[op(v,2)])]); 
		ieqs:=subs(ieqs,[xc[op(v,2)]=cos(xc[op(v,2)])*tan(yc[op(v,2)]),
					     yc[op(v,2)]=sin(xc[op(v,2)])*tan(yc[op(v,2)])]); 		   
 	 end_for;
  end_if;
  // Ende Kugel   
  vars:=[xc[obj],yc[obj],op(restvars),op(vars)];
  eqs:=select(eqs,e->not(bool(domtype(float(eq2term(e)))=DOM_FLOAT)));
  ieqs:=select(ieqs,e->not(bool(domtype(float(eq2term(e)))=DOM_FLOAT)));
  ieqs:=map(ieqs,eq->eq-FXExtraIEdist);
  eqs:=travSimplSinCos(eqs); ieqs:=travSimplSinCos(ieqs);
  if FXdebug then 
     print("SetOtim:",(xziel-xc[obj])^2+(yziel-yc[obj])^2,vars,float(eqs),float(ieqs),[xziel,yziel]);
  end_if;  
  if 0=traperror(SetOptim(FXzielFaktor*((xziel-xc[obj])^2+(yziel-yc[obj])^2),
                          vars,float(eqs),float(ieqs),[xziel,yziel])) 
	then 
    FXStack::push([ vars, [getVar(xc[obj]),getVar(yc[obj]),op(restvals),op(ivals)] ] );
    return([ vars, [getVar(xc[obj]),getVar(yc[obj]),op(ivals)] ]);
  else return("ERROR:".getlasterror()[2]);
  end_if;
end_proc:

doMoveDonlpR:=proc(ziel:DOM_LIST) // mit repaint 
local res;
begin
    res:=doMoveDonlp(ziel);
  	if FXallowJava then java::DGSFelix::updConfig(felixHandle,expr2text(res)); end_if; 
    FelixRepaint();
end_proc:

doMoveDonlp:=proc(ziel) // ohne repaint 
local fiv,xy,k,i,allvars,ivals,res,javares,value,nls;
begin
  if domtype(ziel)=DOM_STRING then ziel:=text2expr(ziel); end_if;
  if LastDONLPInfo=[] then error("DonLPSetup-step fehlt!"); end_if;
  if FXcorr then ziel:=[ziel[1]+FXoffset[1],ziel[2]+FXoffset[2]]; end_if;
  [allvars,ivals]:=FXStack::top();
  if nops(ziel)<>2 then error("Zwei Zielkoordinaten mssen angegeben werden!"); end_if;
  if FXdebug then print("Startet NOptim",ivals,[ziel[1],ziel[2]]); end_if;
  NOsetr(1);NOsetRandR(FXRandomR); // Versuchsweise ??
  fiv:=float(ivals);
  if 0<>traperror((res:=NOptim(fiv,[ziel[1],ziel[2]]))) then  //Fehler? Nochmal nher an Ziel
    //fiv[1]:=(fiv[1]+ziel[1])/2;fiv[2]:=(fiv[2]+ziel[2])/2; res:=NOptim(fiv,[ziel[1],ziel[2]])
    error(lasterror());
  end_if;
  FXStack::push([allvars,res]);
  if FXuseSPH then
    for k from 1 to nops(FXSPH) do
	  xy:=S2K([res[2+FXSPH[k][1]],res[2+FXSPH[k][2]]]);  //+2 bercksichtigt vorgesch vars des Zugpunktes
      res[2+FXSPH[k][1]]:=xy[1]; res[2+FXSPH[k][2]]:=xy[2];
	end_for;
  end_if; /* FXuseSPH */ 
  javares:=[]; 
  for i from 1 to nops(res) do
    if headtype(allvars[i])<>WI then 
		setVar0(allvars[i],res[i]);
		javares:=append(javares,allvars[i]);
		javares:=append(javares,res[i]);
	else
		setVar0(ac[op(allvars[i],2)],float(sin(res[i])));
		setVar0(bc[op(allvars[i],2)],float(cos(res[i])));
		javares:=append(javares,ac[op(allvars[i],2)]);
		javares:=append(javares,float(sin(res[i])));
		javares:=append(javares,bc[op(allvars[i],2)]);
		javares:=append(javares,float(cos(res[i])));
	end_if;
  end_for;
  if FXuseLP and nops(FXLPsubs)>0then  // Linears prepeocessing
     nls:=[]; for i from 0 to nops(javares)/2-1 do
       nls:=[op(nls),javares[1+2*i]=javares[2+2*i]];
	 end_for;
	 for i from 1 to nops(res) do
	     if headtype(allvars[i])=WI then
 		   nls:=[op(nls),allvars[i]=res[i]];
		 end_if;
	 end_for;
     for i from 1 to nops(FXLPsubs) do
	   if 0=traperror((value:= float(subs(op(FXLPsubs[i],2),nls)))) then
 	     setVar0(op(FXLPsubs[i],1), value);
		 javares:=append(javares,op(FXLPsubs[i],1));
		 javares:=append(javares,value);
	   else
	   end_if;
	 end_for;
  end_if; // Lineares Preprocessing
  javares
end_proc:

closeMoveDonlp:= proc() begin FXStack:=adt::Stack(): FXLPsubs:=[]: end_proc:


/* MINIMIZE DONLP strategy  Pernalty Methode--------------------------------------------------------*/

FXpenalty:=100:

prepareMoveDonlpPenalty:=proc(obj:DOM_STRING) 
local f,bo,i,j,eqs,ieqs,vars,ivals,v;
save xziel,yziel;
begin
  if getType(obj)<>"point" then error("Nur Punkte direkt ziehbar!"); end_if;
  delete xziel,yziel;
  normalizeLines0();
  eqs:=map(getEquations(),eq2term); ieqs:=map(getInEquations(),ieq2term);
  bo:=listlib::setDifference(BasicObjects,[obj]);  // Diese Koordinaten werden eingesetzt!
  // print("Einzusetzende Objekte: ",bo);
  eqs:=insertValuesOf(eqs,bo);
  ieqs:=insertValuesOf(ieqs,bo);
  normalizeLines0();
  vars:=[]; ivals:=[]; objvars:=[]; j:=0;
  for i from 1 to nops(Config) do
  	v:=op(Config[i],1);
	if op(v,2)=obj then objvars:=[objvars,v]; 
	else
	  if not(has(bo,op(v,2))) then
		if headtype(v)=ac or headtype(v)=bc then 
		  if not(has(vars,WI[op(v,2)])) then
				vars:=[op(vars),WI[op(v,2)]]; 
				ivals:=[op(ivals),angleOfLine(op(v,2))];
				eqs:=subs(eqs,  ac[op(v,2)]=sin(WI[op(v,2)]),bc[op(v,2)]=cos(WI[op(v,2)])); 
				ieqs:=subs(ieqs,ac[op(v,2)]=sin(WI[op(v,2)]),bc[op(v,2)]=cos(WI[op(v,2)])); 
		  end_if;
		else // Normalfall 
		vars:=[op(vars),v]; ivals:=[op(ivals),op(Config[i],2)];
		end_if;
		j:=j+1; 
	  end_if;
	 end_if;
  end_for;
  vars:=[xc[obj],yc[obj],op(vars)];
  f:=0; for i from 1 to nops(eqs) do f:=f+eqs[i]^2; end_for;
  if 0=traperror(SetOptim((xziel-xc[obj])^2+(yziel-yc[obj])^2+FXpenalty*f,vars,[],ieqs,[xziel,yziel])) then 
    FXStack::push([ vars, [getVar(xc[obj]),getVar(yc[obj]),op(ivals)] ] );
    return([ vars, [getVar(xc[obj]),getVar(yc[obj]),op(ivals)] ]);
  else return("ERROR:".getlasterror()[2]);
  end_if;
end_proc:


// doMoveDonlP , closeMoveDonlp wie oben benutzen zum Abschluss




/* MINIMIZE DONLP strategy    POWER --------------------------------------------------------*/

prepareMoveDonlpPower:=proc(obj:DOM_STRING) 
local f,bo,i,j,eqs,ieqs,vars,ivals,v;
begin
  if getType(obj)<>"point" then error("Nur Punkte direkt ziehbar!"); end_if;
  normalizeLines0();
  eqs:=map(getEquations(),eq2term); ieqs:=map(getInEquations(),ieq2term);
  bo:=listlib::setDifference(BasicObjects,[obj]);  // Diese Koordinaten werden eingesetzt!
  // print("Einzusetzende Objekte: ",bo);
  eqs:=insertValuesOf(eqs,bo);
  ieqs:=insertValuesOf(ieqs,bo);
  vars:=[]; ivals:=[]; objvars:=[]; j:=0;
  for i from 1 to nops(Config) do
  	v:=op(Config[i],1);
	if op(v,2)=obj then objvars:=[objvars,v]; 
	else
	  if not(has(bo,op(v,2))) then
		if headtype(v)=ac or headtype(v)=bc then 
		  if not(has(vars,WI[op(v,2)])) then
				vars:=[op(vars),WI[op(v,2)]]; 
				ivals:=[op(ivals),angleOfLine(op(v,2))];
				eqs:=subs(eqs,  ac[op(v,2)]=sin(WI[op(v,2)]),bc[op(v,2)]=cos(WI[op(v,2)])); 
				ieqs:=subs(ieqs,ac[op(v,2)]=sin(WI[op(v,2)]),bc[op(v,2)]=cos(WI[op(v,2)])); 
		  end_if;
		else // Normalfall 
		vars:=[op(vars),v]; ivals:=[op(ivals),op(Config[i],2)];
		end_if;
		j:=j+1; 
	  end_if;
	 end_if;
  end_for;
  f:=0;
  for i from 1 to nops(eqs) do f:=f+eqs[i]^2; end_for;
  if FXdebug then print("Erste Runde",vars,ivals,[],ieqs);
     print("SetOtimPOWER:",f,vars,[],ieqs,[xc[obj],yc[obj]]);
  end_if;
  if 0=traperror(SetOptim(f,vars,[],ieqs,[xc[obj],yc[obj]])) then 
    FXStack::push([ vars, ivals,[xc[obj],yc[obj]], [getVar(xc[obj]),getVar(yc[obj])] ]);
    return([ vars, [getVar(xc[obj]),getVar(yc[obj]),op(ivals)] ]);
	else return("ERROR:".getlasterror()[2]);
	end_if;
end_proc:

doMoveDonlpPowerR:=proc(ziel:DOM_LIST) // mit repaint 
local res;
begin
    res:=doMoveDonlpPower(ziel);
  	if FXallowJava then java::DGSFelix::updConfig(felixHandle,expr2text(res)); end_if; 
    FelixRepaint();
end_proc:

doMoveDonlpPower:=proc(ziel) // ohne repaint 
local oldo,ov,i,allvars,ivals,res,javares;
begin
  if domtype(ziel)=DOM_STRING then ziel:=text2expr(ziel); end_if;
  if LastDONLPInfo=[] then error("DonLPSetup-step fehlt!"); end_if;
  [allvars,ivals,ov,oldo]:=FXStack::top();
  if nops(ziel)<>2 then error("Zwei Zielkoordinaten mssen angegeben werden!"); end_if;
  if FXdebug then print("Startet NOptim",ivals,[ziel[1],ziel[2]]); end_if;
  NOsetr(1);NOsetRandR(2.0);
  res:=NOptim(float(ivals),[ziel[1],ziel[2]]);
  FXStack::push([allvars,res,ov,ziel]);
  javares:=[]; 
  for i from 1 to nops(res) do
    if headtype(allvars[i])<>WI then 
		setVar0(allvars[i],res[i]);
		javares:=append(javares,allvars[i]);
		javares:=append(javares,res[i]);
	else
		setVar0(ac[op(allvars[i],2)],float(sin(res[i])));
		setVar0(bc[op(allvars[i],2)],float(cos(res[i])));
		javares:=append(javares,ac[op(allvars[i],2)]);
		javares:=append(javares,float(sin(res[i])));
		javares:=append(javares,bc[op(allvars[i],2)]);
		javares:=append(javares,float(cos(res[i])));
	end_if;
  end_for;
  setVar0(ov[1],ziel[1]); setVar0(ov[2],ziel[2]);
  [op(javares),ov[1],ziel[1],ov[2],ziel[2]]
end_proc:

closeMoveDonlpPower:= proc() begin FXStack:=adt::Stack(): RelaxDonlpR(); end_proc:



// DONLP RELAX ===================================================================

RelaxDonlpR:=proc() // mit repaint 
local res;
begin
    res:=RelaxDonlp();
  	if FXallowJava then java::DGSFelix::updConfig(felixHandle,expr2text(res)); end_if; 
    FelixRepaint();res
end_proc:

RelaxDonlp:=proc() 
local javares,res,f,bo,i,j,eqs,ieqs,vars,ivals,v;
begin
  eqs:=map(getEquations(),eq2term); ieqs:=map(getInEquations(),ieq2term);
  bo:=BasicObjects;  // Diese Koordinaten werden eingesetzt!
  normalizeLines0();
  eqs:=insertValuesOf(eqs,bo); ieqs:=insertValuesOf(ieqs,bo);
  vars:=[]; ivals:=[];  j:=0;
  for i from 1 to nops(Config) do
  	v:=op(Config[i],1);
	if not(has(bo,op(v,2))) then // alte Bedingung: not(has(bo,op(v,2)))
		if headtype(v)=ac or headtype(v)=bc then 
		  if not(has(vars,WI[op(v,2)])) then
				vars:=[op(vars),WI[op(v,2)]]; 
				ivals:=[op(ivals),angleOfLine(op(v,2))];
				eqs:=subs(eqs,  ac[op(v,2)]=sin(WI[op(v,2)]),bc[op(v,2)]=cos(WI[op(v,2)])); 
				ieqs:=subs(ieqs,ac[op(v,2)]=sin(WI[op(v,2)]),bc[op(v,2)]=cos(WI[op(v,2)])); 
		  end_if;
		else // Normalfall 
		vars:=[op(vars),v]; ivals:=[op(ivals),op(Config[i],2)];
		end_if;
		j:=j+1; 
	  end_if;
  end_for;
  f:=fp::apply(_plus,op(map(eqs,a->a^2)));
  if  FXdebug then print("Relax: Erste Runde",vars,ivals,eqs,ieqs);
     print("SetOtim:",f,vars,[],ieqs,[]);
  end_if;
  if 0<>traperror(SetOptim(f,vars,[],ieqs,[])) then
     return("ERROR:".getlasterror()[2]); 
  end_if;
  res:=NOptim(float(ivals),[]);
  javares:=[]; 
  for i from 1 to nops(res) do
    if headtype(vars[i])<>WI then 
		setVar0(vars[i],res[i]);
		javares:=append(javares,vars[i]);
		javares:=append(javares,res[i]);
	else
		setVar0(ac[op(vars[i],2)],float(sin(res[i])));
		setVar0(bc[op(vars[i],2)],float(cos(res[i])));
		javares:=append(javares,ac[op(vars[i],2)]);
		javares:=append(javares,float(sin(res[i])));
		javares:=append(javares,bc[op(vars[i],2)]);
		javares:=append(javares,float(cos(res[i])));
	end_if;
  end_for;
  javares
end_proc:


// Utilities--------------------
 
makeMangleLists:=proc( L:DOM_LIST)
  // returns [a,b] where a is a a substlist [xc("P1")=g7[1],....] and 
  // b is a substlist [g7[1]=xc("P1"),....] that are inverses of each other
  local a,b,i,s;
begin
	s:=genident("manglevar");
        a:=[]; b:=[];
	for i from 1 to nops(L) do
		a:=[op(a),L[i]=s[i]]; b:=[op(b),s[i]=L[i]];
	end_for;
	[a,b]
end_proc:

makeMangleListsV2:=proc( L:DOM_LIST)
  // returns [a,b] where a is a a substlist [xc("P1")=g7[1],....] and 
  // b is a substlist [g7[1]=xc("P1"),....] that are inverses of each other
  local a,b,i,s;
begin
        a:=[]; b:=[];
	for i from 1 to nops(L) do
		s:=genident("manglevar");
		a:=[op(a),L[i]=s]; b:=[op(b),s=L[i]];
	end_for;
	[a,b]
end_proc:

ITsubs:=proc(a,su)
local b;
begin
while(TRUE) do
b:=subs(a,su);
if a=b then return(a); end_if;
a:=b;
end_while;
end:

selfSubs:=proc(s)
local s1,i,b,rs,v;
begin
v:=map(s,e->op(e,1));
while(TRUE) do
rs:=map(s,e->op(e,2));
rs:=subs(rs,s);
s1:=zip(v,rs,(l,r)->l=r);
if s1=s then return(s1); end_if;
s:=s1; 
end_while;
end_proc: 

// Mathematische Minprocs


setLength:=proc(obj:DOM_STRING, l)
begin
  if getType(obj)="vector" then return(addEquationComment(vx[obj]^2+vy[obj]^2=l^2,obj." Laenge=".expr2text(l))); end_if; 
  if getType(obj)="circle" then return(addEquationComment(rc[obj]=l,obj." Radius=".expr2text(l))); end_if; 
  error("Wrong type");
end_proc:

setEqual:=proc(a:DOM_STRING, b:DOM_STRING)
local at,bt;
begin
  at:=getType(a); bt:=getType(b);
  if at="vector" and bt="vector" then 
     return(addEquationComment(vx[a]^2+vy[a]^2=vx[b]^2+vy[b]^2,a." laengengleich ".b)); end_if; 
  if at="circle" and bt="vector" then 
     return(addEquationComment(rc[a]^2=vx[b]^2+vy[b]^2,a." laengengleich ".b)); end_if; 
  if bt="circle" and at="vector" then 
     return(addEquationComment(rc[b]^2=vx[a]^2+vy[a]^2,a." laengengleich ".b)); end_if; 
  if at="circle" and bt="circle" then 
     return(addEquationComment(rc[a]=rc[b],a." laengengleich ".b)); end_if; 
  error("Wrong type");
end_proc:

norm2d:= c -> sqrt(c[1]^2+c[2]^2):


Dist:= (a,b)->insertValues(dist(a,b)):
Dist2:= (a,b)->insertValues(dist2(a,b)):
Len:= (a,b)->insertValues(len(a)):
 
dist:=proc(p,q)
local tp,tq;
begin
	p:=name2str(p); q:=name2str(q);
	tp:=getType(p); tq:=getType(q);
	if tp="point" and tq="point" then return(sqrt((xc[p]-xc[q])^2+(yc[p]-yc[q])^2)); end_if;
	if tp="line" and tq="point" then return(dist(q,p)); end_if;
	if tp="point" and tq="line" then return(abs((ac[q]*xc[p]+bc[q]*yc[p]-cc[q])/sqrt(ac[q]^2+bc[q]^2))); end_if;
	if tp="circle" and tq="point" then return(dist(q,p)); end_if;
    if tp="point" and tq="circle" then return(abs(rc[q]-sqrt((xc[p]-xc[q])^2+(yc[p]-yc[q])^2))); end_if;
    hold(dist)(p,q)
end_proc:

dist2:=proc(p,q)
local tp,tq;
begin
	p:=name2str(p); q:=name2str(q);
	tp:=getType(p); tq:=getType(q);
	if tp="point" and tq="point" then return((xc[p]-xc[q])^2+(yc[p]-yc[q])^2); end_if;
	if tp="line" and tq="point" then return(dist(q,p)); end_if;
	if tp="point" and tq="line" then return( (ac[q]*xc[p]+bc[q]*yc[p]-cc[q])^2/(ac[q]^2+bc[q]^2)); end_if;
	if tp="circle" and tq="point" then return(dist(q,p)); end_if;
    if tp="point" and tq="circle" then return((rc[q]-sqrt((xc[p]-xc[q])^2+(yc[p]-yc[q])^2))^2); end_if;
    hold(dist)(p,q)
end_proc:

len:=proc(v)
local tv;
begin
	v:=name2str(v); 
	tv:=getType(v); 
	if tv="vector"  then return(sqrt(vx[v]^2+vy[v]^2)); end_if;
	if tv="circle"  then return(2*PI*rc[v]); end_if;
    hold(len)(v)
end_proc:

 
angle0:=proc(n) 
begin 
	n:=name2str(n);
  if getType(n)="line" then return(-sign(ac[n])*arccos(bc[n]/sqrt(ac[n]^2+bc[n]^2))); end_if;
  if getType(n)="vector" then return(sign(vy[n])*arccos(vx[n]/sqrt(vx[n]^2+vy[n]^2))); end_if;
  error("Unkown object type!");
end_proc:
  
angle:=proc(g,h)
local w,wf;
begin
	g:=name2str(g); h:=name2str(h);
	w:=angle0(h)-angle0(g);
	wf:=float(w);
	if domtype(wf)=DOM_FLOAT then 
		if wf>float(2*PI) then return(w-2*PI)
 	    elif wf<0 then return(w+2*PI)
		else return(w);
 	    end_if;
	else
	  return(w);
    end_if;
 end_proc:

angledeg:= (a,b)->float(180/PI*angle(a,b)):

colinear:= proc(a,b,c)
begin
  a:=name2str(a);
  b:=name2str(b);
  c:=name2str(c);
  return(0=(xc[b]*yc[c]-xc[c]*yc[b]) -(xc[a]*yc[c]-xc[c]*yc[a]) +(xc[a]*yc[b]-xc[b]*yc[a]))
end_proc:


name2str:= a -> if domtype(a)=DOM_IDENT then expr2text(a); else a end_if:


// Projection on objects !!!!!!!!!!!!!!!!!!!!!!!!!!!!

projectPointTo:=proc(p:DOM_STRING, obj:DOM_STRING)
local co1,coxy;
begin
  if not(getType(p))="point" then error("Punkt erforderlich!"); end_if;
  co1:=insertValues([xc[p],yc[p]]); 
  coxy:=projectTo(co1,obj); 
  if coxy=FAIL then error("Projektion gescheitert!"); end_if;
  setVar(xc[p],coxy[1]);setVar(yc[p],coxy[2]);
  return([coxy[1],coxy[2]]);
end_proc:

projectTo:=proc(co:DOM_LIST, obj:DOM_STRING)
local eq,lc,R,typ,xx,yy,x,y,xcc,ycc,rcc,lambda; 
save varx,vary;
begin
	if nops(co)<>2 then error("projectTo projeziert nur 2d-Punkte!"); end_if;
	delete varx, vary;
	co:=float(co); [x,y]:=co;
	typ:=getType(obj);
	if typ=null() then error("Unbekannter Trger!"); 
	elif typ="point" then return(insertValues([xc[obj],yc[obj]]));
	elif typ="circle" then 
		xcc:=getVar(xc[obj]); ycc:=getVar(yc[obj]); rcc:=getVar(rc[obj]); 
		R:=float(sqrt((x-xcc)^2+(y-ycc)^2));
		if abs(R)<numeps then return([xcc+rcc,ycc]) end_if; 
		return(float([xcc+(x-xcc)/R*rcc,ycc+(y-ycc)/R*rcc]));
	elif typ="line" then 
		lc:=[getVar(ac[obj]),getVar(bc[obj]),getVar(cc[obj])];
 		lambda:=(lc[3]-lc[1]*x-lc[2]*y)/(lc[1]^2+lc[2]^2);
		return(float([x+lambda*lc[1],y+lambda*lc[2]]));
   else eq:=getEquationOf(obj,varx,vary); 
          if type(eq)="_equal" then
            f:=op(eq,1)-op(eq,2);  
	          f:=insertValues(f)^2; 
	          SetOptim(f,[varx,vary],[],[],[]);
            return(NOptim(co,[]));
          else FAIL end_if;
	 end_if;
end_proc:
:

// safe calling --------------------

savecalls:=proc(a) // a ist String, der sicher ausgefhrt wird
	local res,em, FXa;
begin
	if domtype(a)<>DOM_STRING then return(FAIL); end_if;
	FXa:=FXallowJava;
	FXallowJava:=FALSE;
	em:=traperror(_assign(res,eval(text2expr(a))));
	FXallowJava:=FXa;
	if em=0 then res else "ERROR:".getlasterror()[2] end_if;
end_proc:

savecallsTime:=proc(a,t) // a ist String, der sicher ausgefhrt wird, t maximale Zeit (Sek.)
	local res,em, FXa;
begin
	if domtype(a)<>DOM_STRING then return(FAIL); end_if;
	FXa:=FXallowJava;
	FXallowJava:=FALSE;
	em:=traperror(_assign(res,eval(text2expr(a))),t);
	FXallowJava:=FXa;
	if em=0 then return(res) else 
	if em=1320 then return("ERROR:!Time-OUT") else return("ERROR:".getlasterror()[2]) end_if; end_if;
end_proc:

savecallsJ:=proc(a) // a ist String, der sicher ausgefhrt wird, erluabt Sprung nach java
	local res,em;
begin
	if domtype(a)<>DOM_STRING then return(FAIL); end_if;
	em:=traperror(_assign(res,eval(text2expr(a))));
	if em=0 then res else FAIL end_if;
end_proc:




 //----------------- Tools fr Lineares Preprocessing ----------------


LinPreSolve:=proc(eqs0,vars) 
local t,sol,found,lvs,nlvars,i,j,sr,eqs,v;
begin
	nlvars:=[]; /* nichtlineare Variablen */
	lvs:=[]; /* lineare Variablen mit Ausrechengelel, lv=[v1=...,v2=...] */ 
	vars:=reverse(vars); eqs:=map(reverse(eqs0),eq2term);
	for i from 1 to nops(vars) do
		v:=vars[i]; found:=FALSE; 
		if not(headtype(v)=cc) and not(has(lvs,v)) then  
			for j from 1 to nops(eqs) do
  				t:=isLinearIn(eqs[j],v);
  				if nops(t)=2 and not(hasvars(t[1],vars)) then
  					sol:= v=-t[2]/t[1];
					eqs[j]:=null();
  					found:=TRUE; break;
  				end_if;
			end_for;
		end_if;
		if found then lvs:=[op(lvs),sol]; else nlvars:=[v,op(nlvars)]; end_if;
	end_for;
	[lvs,nlvars,subs(eqs,op(lvs))]
end_proc:

hasvars:=proc(term,vl:DOM_LIST)
local i;
begin
for i from 1 to nops(vl) do
  if has(term,vl[i]) then return(TRUE); end_if;
end_for:
FALSE
end_proc:


reverse:=proc(L:DOM_LIST)
local i,r;
begin
r:=L;
for i from 1 to nops(L) do r[nops(L)+1-i]:=L[i]; end_for;
r
end_proc:

// Beispiel: isLinearIn(4*(y+x+1),x)
isLinearIn:=proc(term,var)
local c,r;
begin
c:=coeff(term,var,1);
if c=0 then return([]); end_if;
r:=coeff(term,var,0);
if expand(term-(c*var+r))=0 and c<>0 then [c,r] else [] end_if;
end_proc:

/*======================= Minimale Realitionskurvenberechnung ===============================*/

// Variablen durch fr simplify geeinete Form ersetzen
inertUndoTable:={}:
inertFVinverse:= a -> subs(a,inertUndoTable): // siehe auch unInertFV
clearInertTable:=proc() begin inertUndoTable:={}: end_proc:
inertFV:=proc(a)
local v;
begin
if type(a)="_index" then 
   if has(FelixVarHeads,op(a,1)) then v:=text2expr(expr2text(op(a,1))."_i_".op(a,2)) 
   else v:=text2expr(expr2text(op(a,1))."_i_".expr2text( op(a,2)))
   end_if;
   inertUndoTable:={v=a} union inertUndoTable;
   v
elif atomicTypeQ(a) then a else map(a,inertFV) end_if  
end_proc:

unInertFV:=proc(a) // wie inertFVinverse, langsamer, 
  //geht aber auch wenn die undo-Table nicht mehr aktuell ist
local as;
begin
if domtype(a)=DOM_IDENT then
as:=expr2text(a); 
if length(as)>5 then 
   if as[1..5]="ac_i_"then return(ac[as[6..length(as)]]); end_if; end_if;
if length(as)>5 then 
   if as[1..5]="bc_i_"then return(bc[as[6..length(as)]]); end_if; end_if;
if length(as)>5 then 
   if as[1..5]="cc_i_"then return(cc[as[6..length(as)]]); end_if; end_if;
if length(as)>5 then 
   if as[1..5]="xc_i_"then return(xc[as[6..length(as)]]); end_if; end_if;
if length(as)>5 then 
   if as[1..5]="yc_i_"then return(yc[as[6..length(as)]]); end_if; end_if;
if length(as)>5 then 
   if as[1..5]="rc_i_"then return(rc[as[6..length(as)]]); end_if; end_if;
if length(as)>5 then 
   if as[1..5]="vx_i_"then return(vx[as[6..length(as)]]); end_if; end_if;
if length(as)>5 then 
   if as[1..5]="vy_i_"then return(vy[as[6..length(as)]]); end_if; end_if;
return(a);
end_if;
if atomicTypeQ(a) then return(a); end_if;
map(a,unInertFV)
end_proc:



isEasy:=proc(eq,x,forbidden:DOM_LIST) /* Ist eq leicht nach var lsbar? - Rckgabe FAIL oder term fr var */
local i,c,pol,lhs,rhs;   /* forbidden-Variablen drfen nicht in den Nenner */
begin
  eq:=eq2term(eq); pol:=poly(eq,[x]); 
  if degree(pol)<>1 then return(FAIL); end_if;
  for i from 1 to nops(forbidden) do 
    if has(coeff(pol,x,1),forbidden[i]) then return(FAIL); end_if; 
  end_for; 
  if coeff(pol,x,1)=0 then return(FAIL); end_if;
  -coeff(pol,x,0)/coeff(pol,x,1)
end_proc:



square:= proc(a) // vereinfachendes quadrieren
begin 
if type(a)="abs" then return(op(a,1)^2); end_if:
if isSqrt(a) then return(op(a,1)) end_if;
if type(a)="_power" and op(a,2)=-1 then return(1/square(op(a,1))) end_if;
if type(a)="_power" then return(op(a,1)^(op(a,2)*2)); end_if:
if type(a)="_mult" then return(map(a,square)); end_if:
a^2
end_proc:

realsimp:= proc(a) /* Entfernt abs(x)^2 */
local x;
begin 
if atomicTypeQ(a) then a 
elif type(a)="abs" then 
   x:=op(a,1);
   if type(x)="_power" then 
     if testtype(op(x,2),Type::Even) then realsimp(op(x,1))^op(x,2) else abs(realsimp(op(x,1))^op(x,2)) end_if
   else
     abs(realsimp(x))
   end_if
elif type(a)="_power" and testtype(op(a,2),Type::Even) then
   x:=op(a,1);    if type(x)="abs" then  realsimp(op(x,1))^op(a,2) else realsimp(x)^op(a,2) end_if
else map(a,realsimp) end_if
end_proc:

isSqrt:=proc(a) begin
if type(a)=type(sqrt(2)) then bool(op(a,2)=1/2) else FALSE end_if
end_proc: 

simpEq:=proc(eq)  // Vereinfach Gleichungen durch Wegnehmen von Wurzeln
local l,r;
begin
l:=lhs(eq); r:=rhs(eq);
if isSqrt(l) and isSqrt(r) then return(op(l,1)=op(r,1)) end_if;
if isSqrt(l)  then return(op(l,1)=square(r)) end_if;
if isSqrt(r)  then return(op(r,1)=square(l)) end_if;
if type(l)="abs" and type(r)="abs" then return(square(op(l,1))=square(op(r,1))); end_if; 
if type(l)="abs" then return(square(op(l,1))=square(r)); end_if; 
if type(r)="abs" then return(square(op(r,1))=square(l)); end_if; 
l=r
end_proc:

hasSqrt:= proc(a) 
local x,i;
begin 
if atomicTypeQ(a) then FALSE 
elif type(a)="_power" then 
   if domtype(op(a,2))=DOM_RAT then TRUE else 
       return(hasSqrt(op(a,1)) or hasSqrt(op(a,2)));
   end_if;
elif domtype(a)=DOM_SET or domtype(a)=DOM_LIST then 
for i from 1 to nops(a) do if hasSqrt(a[i]) then return(TRUE); end_if; end_for;
else  for i from 1 to nops(a) do if hasSqrt(op(a,i)) then return(TRUE); end_if; end_for;
return(FALSE);
end_if;
end_proc:

SimpEq:=proc(eq)  // Vereinfach Gleichungen durch Wegnehmen von Wurzeln
local u,l,r,t,i;
begin
if type(eq)<>"_equal" then return(eq); end_if;
l:=lhs(eq); r:=rhs(eq);
if isSqrt(l) and isSqrt(r) then return(op(l,1)=op(r,1)) end_if;
if isSqrt(l)  then return(op(l,1)=square(r)) end_if;
if isSqrt(r)  then return(op(r,1)=square(l)) end_if;
if type(l)="abs" and type(r)="abs" then return(square(op(l,1))=square(op(r,1))); end_if; 
if type(l)="abs" then return(square(op(l,1))=square(r)); end_if; 
if type(r)="abs" then return(square(op(r,1))=square(l)); end_if; 
if (hasSqrt(l) and hasSqrt(r)) or (not(hasSqrt(l)) and not(hasSqrt(r))) then return(l=r); end_if;
if hasSqrt(r) and not(hasSqrt(l)) then t:=r; r:=l; l:=t; end_if;
// Jetzt sqrt links
u:=0;
if type(l)="_plus" then 
  for i from 1 to nops(l) do if not(hasSqrt(op(l,i))) then u:=u+op(l,i); end_if; end_for;
  if u=0 then return(l=r) else return(SimpEq(l-u=r+u)); end_if;
elif type(l)="_mult" then u:=1; 
  for i from 1 to nops(l) do if not(hasSqrt(op(l,i))) then u:=u*op(l,i); end_if; end_for;
  if u=1 then return(l=r) else return(SimpEq(l/u=r/u)); end_if;
else return(l=r);
end_if;
end_proc:

simpEqNi:=proc(i:DOM_INT)
begin
  if i<1 or i>nops(Equations) then error("Out of Equation range!"); end_if;
  Equations[i]:=inertFVinverse(Simplify(SimpEq(inertFV(Equations[i]))));
  Equations[i]
end_proc:

removeAt:=proc(L:DOM_LIST,i)
begin
if i<1 or i>nops(L) then L else [op(L,1..i-1),op(L,i+1..nops(L))] 
end_if
end_proc:

/*
if version()[1]=3 then
  isacvar:= s -> strmatch(expr2text(s),"ac\*"):
  isbcvar:= s -> strmatch(expr2text(s),"bc\*"):
  isccvar:= s -> strmatch(expr2text(s),"cc\*"):
else
  isacvar:= s -> strmatch(expr2text(s),"ac"):
  isbcvar:= s -> strmatch(expr2text(s),"bc"):
  isccvar:= s -> strmatch(expr2text(s),"cc"):
end_if:
*/
if version()[1]<4 then print("Achtung, diese Version von FeliX ist fr MuPAD4.0 ausgelegt"); end_if:
  isacvar:= s -> strmatch(expr2text(s),"ac"):
  isbcvar:= s -> strmatch(expr2text(s),"bc"):
  isccvar:= s -> strmatch(expr2text(s),"cc"):


forgetabs:= proc(a) /* Entfernt abs */
local x;
begin 
if atomicTypeQ(a) then a 
elif type(a)="abs" then 
   forgetabs(op(a,1))
else map(a,forgetabs) end_if
end_proc:

RelCurveSimpleinxy:=proc(obj:DOM_STRING,x,y) 
local res;
begin
  if traperror((res:=RelCurveSimple(obj)),60)<>0 then return(FAIL); end_if;
  if res=FAIL then res else subs(res,xc[obj]=x,yc[obj]=y) end_if
end_proc:
  



extractConditions:=proc(e) /* bestimmt Ungleichungen, die den term reell berechnbar machen  */  
local a,i,z,n;
begin
if atomicTypeQ(e) then return({}); end_if;
if type(e)="arcsin" or type(e)="arccos" then return({op(e,1)<=1,op(e,1)>=-1,op(extractConditions(op(e,1)))}); end_if;
if type(e)="ln"  then return({op(e,1)>0,op(extractConditions(op(e,1)))}); end_if;
if type(e)="_power" then 
     if domtype(op(e,2))=DOM_RAT then return({op(e,1)>0,op(extractConditions(op(e,1))),op(extractConditions(op(e,2)))});
     else return({op(extractConditions(op(e,1))),op(extractConditions(op(e,2)))}); end_if;
end_if;
a:={};
   for i from 1 to nops(e) do
      a:={op(a),op(extractConditions(op(e,i)))};
   end_for;
 a
end_proc:


addConditions:=proc()
local i,n,conds;
begin
  conds:={}; n:=nops(Equations);
  for i from 1 to n do conds:={op(conds),extractConditions(Equations[i])}; end_for;
  map(conds,c->if not(has(Equations,c)) then addEquation(c) end_if);
end:


// Wahl des Algorithmus die die Relationskurvenbestimmung  
FXRCS:=1:  
  
  
// RelCurveSimple:=proc(obj:DOM_STRING) begin inertFVinverse(realsimp(RelCurveSimple0(obj))) end_proc:

RelCurveSimple:=proc(obj:DOM_STRING) 
begin 
  if FXRCS=0 then inertFVinverse(RelCurveSimple0(obj)) else inertFVinverse(RelCurveSimple1(obj)) end_if 
end_proc:


RelCurveSimple0:=proc(obj:DOM_STRING) // 1. Variante 
local devL,nv,ne,e11,varsofobj,erfolg,e,e1,iterate,ev0,deqs,dev,xcv,ycv,j,i,basicvars,elimvars,vars, temp,eqs,eqs0,eqs1;
save todel,uu;
begin
  delete todel,uu;
  clearInertTable(); 
  vars:=inertFV(varsInvolved(getEquations())); eqs:=inertFV(getEquations());
  basicvars:=inertFV({op(map(map(BasicObjects,varsOf),op))});
  varsofobj:=inertFV({xc[obj],yc[obj]});
  elimvars:=vars minus (basicvars union  varsofobj);
  xcv:=inertFV(xc[obj]); ycv:=inertFV(yc[obj]);
  othervars:=basicvars minus varsofobj; //print("othervars=",othervars);
  e1:=realsimp(map(eqs,simpEq)); 
  elimvars:=[op(elimvars)]; //print("***",elimvars);
  for i from 1 to nops(e1) do
    e:=e1[i]; erfolg:=FALSE;
    for j from 1 to nops(elimvars) do
       if not(isccvar(elimvars[j])) then easy:=isEasy(e,elimvars[j],[]);
         if not(easy=FAIL) then  
            erfolg:=TRUE; e1[i]:=todel; e1:=subs(e1,elimvars[j]=easy); 
            elimvars:=subs(elimvars,elimvars[j]=null()); //print("jetzt.",elimvars);
        break; end_if; end_if;
     end_for;
       if erfolg then continue; end_if;
    for j from 1 to nops(othervars) do 
       if not(isccvar(othervars[j])) then easy:=isEasy(e,othervars[j],elimvars);
         //print("eq=",e," var=",othervars[j], "resutlt=",easy);
         if not(easy=FAIL) and nops(indets(easy))=0 then  //print("Othervar ",othervars[j],"eliminiert");
            erfolg:=TRUE; e1[i]:=todel; e1:=subs(e1,othervars[j]=easy); 
           othervars:=subs(othervars,othervars[j]=null());
        break; end_if; end_if; 
     end_for; /* j ber vars*/
  end_for;
elimvars:={op(elimvars)};
//print("Nach Easy: elimvars=",elimvars);
  e1:=subs(e1,todel=null()); 
  e11:=[]; /*print("vor sqrtRepl",e1);*/
  [e1,nv,e11]:=sqrtRepl(e1,uu); //print("liefert",[e1,nv,e11]);
  elimvars:=elimvars union {op(nv)}; e1:=[op(e1),op(e11)];
  e1:=[op(e1),op(e11)]; /*print("Gleichungen:",e1);*/
	eqs0:=map(forgetabs(map(e1,eq2term)),numer); //print("eqs0=",eqs0,"elimvars=",elimvars);
  iterate:=proc() local counter,old,firstloop,i,j,e,e1; begin 
    firstloop:=TRUE; counter:=1;
    while TRUE do
      old:=eqs0;
      vars:=indets(eqs0);
   	   elimvars:=vars minus (basicvars union  varsofobj);
      //print("RelCurveSimple vars=",vars, "elimvars=",elimvars,"basicvars=",basicvars);
      deqs:=select(eqs0,p-> has(p,xcv) or has(p,ycv));
      dev:=(indets(deqs) minus basicvars) minus {xcv,ycv};
      dev:=select(dev,v->not(isccvar(v))); 
      //print("n(eqs)=",nops(eqs0),"n(elimvars)=",nops(elimvars),"nops(deqs)=",nops(deqs),"nops(dev)=",nops(dev));
      if dev={} then return(deqs); end_if;
      devL:=sort([op(dev)],(x,y)->NoOc(deqs,x)<NoOc(deqs,y));
      ev0:=[op(devL),op(elimvars minus dev)];
      ev0:=LineVarsDown(ev0);
      erfolg:=FALSE; //print("**** ev0=",ev0);
      for i from 1 to nops(ev0) do
         if FALSE and ( isacvar(ev0[i]) or isbcvar(ev0[i])  or isccvar(ev0[i]))then next; end_if; /* cc zunchst nicht */ 
         if FALSE and nops(select(eqs0, es->has(es,ev0[i])))<2 then /*print("Var nur in 1 glg:",ev0[i]);*/ next; end_if;
         /*print("calling elim",[ev0[i]],eqs0);*/
         if traperror((t:=groebner::eliminate(eqs0,[ev0[i]])),10)<>0 then /*print("TE");*/ next; end_if;
         if t=FAIL or t=FALSE or nops(t)=0 or not(has(t,xcv) and has(t,ycv)) then next; end_if;
         //print("Elim(1): ",ev0[i], t);
         if nops(t)=1 then return(t); end_if;
         eqs0:=t;  erfolg:=TRUE; /*print("Erfolg!",ev0[i]);*/
      end_for;
      if not(erfolg) then
      for i from 1 to nops(ev0) do
         if firstloop and isccvar(ev0[i]) then next; end_if; /* cc zunchst nicht */ 
         /*print("calling elim",[ev0[i]],eqs0);*/
         if traperror((t:=groebner::eliminate(eqs0,[ev0[i]])),10)<>0 then /*print("TE");*/ next; end_if;
         if t=FAIL or t=FALSE or nops(t)=0 or not(has(t,xcv) and has(t,ycv)) then next; end_if;
         //print("Elim(2): ",ev0[i],t);
         if nops(t)=1 then return(t); end_if;
         eqs0:=t;  erfolg:=TRUE; //print("Erfolg!",ev0[i]);
      end_for;
      end_if;
      if not(erfolg) then /*print("KEIN ERFOLG! eqs=",eqs0);*/ return(FAIL);end_if;
      for i from 1 to nops(eqs0) do
        e1:=factor(eqs0[i]);
        if type(e1)="_mult" or type(e1)=Factored then e:=1;
		       for j from 1 to nops(e1) do 
            if nops(indets(e1[j]))>1 then e:=e*e1[j]; 
            elif nops(indets(e1[j]))=1 then if not(isccvar(op(indets(e1[j]),1))) then e:=e*e1[j] 
                else /*print("FAKTOR weggelassen:",e1[j]);*/ end_if; else /*print("FAKtoR weggelassen:",e1[j]);*/end_if;
		       end_for;
  	      else e:=e1;
        end_if;
        eqs0[i]:=e;
      end_for;
      firstloop:=FALSE;
      if nops(old)=nops(eqs0) then break; end_if;
      counter:=counter+1;
    end_while;
  end_proc;

  temp:=iterate(); // print("ENDE Itereate=",temp);
  if nops(temp)=0 or temp=FAIL or temp=FALSE then print(temp); return(FAIL); end_if;
  if nops(temp)>1 then 
     temp:=select(temp,eee-> (has(eee,varsofobj[1]) and has(eee,varsofobj[1]) ));
     temp:=reverse(sort(temp)); 
  end_if;
   e1:=factor(temp[1]);
  if type(e1)="_mult" or type(e1)=Factored then e:=1;  // Factored fr MuPAD4.0 notwendig
		 for i from 1 to nops(e1) do 
          if has(e1[i],xcv) and has(e1[i],ycv) then e:=e*e1[i]; end_if;
		 end_for;
  	  else e:=e1;
  end_if;
  e=0
 end_proc:



RelCurveSimple1:=proc(obj:DOM_STRING)  // Zweite Variante 
local /* allelimvars, */ factorReduce,fehler, e1alt, gb,elimvars0, devL,nv,ne,e11,varsofobj,erfolg,e,e1,iterate,ev0,deqs,dev,xcv,ycv,j,i,basicvars,elimvars,vars, temp,eqs,eqs0,eqs1;
save todel,uu;
begin // print("Entering RelCurveSimple0 --------");
  delete todel,uu;
  clearInertTable(); 
  vars:=inertFV(varsInvolved(getEquations())); eqs:=inertFV(getEquations()); 
  basicvars:=inertFV({op(map(map(BasicObjects,varsOf),op))}); 
  //print("Basicbjects=",BasicObjects);
  //print("basicvars=",basicvars);
  //print("inetsect:",basivcars intersect vars);
  varsofobj:=inertFV({xc[obj],yc[obj]});
  elimvars:=vars minus (basicvars union  varsofobj); //print("1.elimvars=",elimvars);
  allelimvars:=elimvars;
  xcv:=inertFV(xc[obj]); ycv:=inertFV(yc[obj]);
  othervars:=basicvars minus varsofobj; //print("othervars=",othervars);
  e1:=realsimp(map(eqs,simpEq)); 
  elimvars:=[op(elimvars)]; //print("*** nops(e1)=",nops(e1),"elimvars=",elimvars);
   for i from 1 to nops(e1) do
    e:=e1[i]; erfolg:=FALSE;
    for j from 1 to nops(elimvars) do
       if not(isccvar(elimvars[j])) then 
           easy:=isEasy(e,elimvars[j],[]);  
         if not(easy=FAIL) then 
              erfolg:=TRUE; e1[i]:=todel; e1alt:=e1;
              fehler:=traperror((   e1:=subs(e1,elimvars[j]=easy); )) ;
              if fehler>0 then e1:=e1alt; 
              else  
                 elimvars:=subs(elimvars,elimvars[j]=null());  
                 break;
              end_if;
       end_if; end_if;
     end_for;
       if erfolg then continue; end_if;
    for j from 1 to nops(othervars) do  
       if not(isccvar(othervars[j])) then easy:=isEasy(e,othervars[j],elimvars);
         //print("eq=",e," var=",othervars[j], "resutlt=",easy);
         if not(easy=FAIL) and nops(indets(easy))=0 then  //print("Othervar ",othervars[j],"eliminiert");
            erfolg:=TRUE; e1[i]:=todel; e1alt:=e1;
            fehler:=traperror(( e1:=subs(e1,othervars[j]=easy) )); 
              if fehler>0 then e1:=e1alt; 
              else  
               othervars:=subs(othervars,othervars[j]=null()); break;
              end_if; 
       end_if; end_if; 
     end_for; /* j ber vars*/
  end_for;
elimvars:={op(elimvars)};
//print("Nach Easy: elimvars=",elimvars);
  e1:=subs(e1,todel=null()); 
  e11:=[]; /*print("vor sqrtRepl",e1);*/
  [e1,nv,e11]:=sqrtRepl(e1,uu); //print("liefert",[e1,nv,e11]);
  elimvars:=elimvars union {op(nv)}; e1:=[op(e1),op(e11)];
  e1:=[op(e1),op(e11)]; /*print("Gleichungen:",e1);*/
	eqs0:=map(forgetabs(map(e1,eq2term)),numer); 
//print("nops(eqs0)=",nops(eqs0),"elimvars=",elimvars);
  elimvars0:=elimvars; elimvars:=[]; 
  for i from 1 to nops(elimvars0) do
      temp:=0;
      for j from 1 to nops(eqs0) do if has(eqs0[j],elimvars0[i]) then temp:=temp+1; end_if; end_for;
      if temp>1 then elimvars:=[op(elimvars),elimvars0[i]] end_if;
   end_for;
  if nops(elimvars)>=nops(eqs0) then 
     elimvars0:=elimvars; elimvars:=[]; ev:=[];
     for i from 1 to nops(elimvars0) do
       if  isacvar(elimvars0[i]) or isbcvar(elimvars0[i]) or isccvar(elimvars0[i]) then
         ev:=[op(ev),elimvars0[i]]; else elimvars:=[op(elimvars),elimvars0[i]];
       end_if;
     end_for;
     ev:=sort(ev);
     if nops(elimvars)>=nops(eqs0) then elimvars:=elimvars[1..(nops(eqs0)-1)]
     else elimvars:=[op(elimvars),op(ev[1..(nops(eqs0)-1-nops(elimvars))])]
     end_if
  end_if:
global_eqs0:=eqs0; //print("Jetzt eliminieren:",elimvars);
//print("Jetzt Factor_Reduce: nops(eqs0)=,nops(elimvars)=,eqs0=",nops(eqs0),nops(elimvars),"elimvars=",elimvars);
  factorReduce:=proc(tt)
    local e1,i,e;
    begin 
      e1:=irredFactorList(tt); 
      e:=1;  
      for i from 1 to nops(e1) do 
                 if indets(e1[i]) minus {op(allelimvars)} <> {} then e:=e*e1[i]; end_if;
      end_for;
      if e<>1 then e else tt end_if
  end_proc;
  fehler:=traperror((eqs0:=map(eqs0,factorReduce)));
  if fehler>0 then print("Fehler in factorReduce"); return(FAIL); end_if;
//print("Jetzt Eliminate: nops(eqs0)=,nops(elimvars)=,eqs0=",nops(eqs0),nops(elimvars),"elimvars=",elimvars);
  if nops(eqs0)>1 then temp:=map(groebner::eliminate(eqs0,elimvars),factor);
  else temp:=map(eqs0,factor); end_if;
  //print("Nach elkiminate: nops=",nops(temp)," :::: ", temp);
  if nops(temp)=0 or temp=FAIL or temp=FALSE then print(temp); return(FAIL); end_if;
  if nops(temp)>1 then 
     temp:=select(temp,eee-> (has(eee,varsofobj[1]) and has(eee,varsofobj[1]) ));
     temp:=reverse(sort(temp)); 
  end_if;
   e1:=factor(temp[1]);
// print("DIE GLEICHUNG ",e1);
  if type(e1)="_mult" or type(e1)=Factored then e:=1;  // Factored fr MuPAD4.0 notwendig
		 for i from 1 to nops(e1) do 
          if has(e1[i],xcv) and has(e1[i],ycv) then e:=e*e1[i]; end_if;
		 end_for;
  	  else e:=e1;
  end_if;
  e=0
 end_proc:




LineVarsDown:=proc(L:DOM_LIST)
local a,b,c,i;
begin
a:=[]; b:=[]; c:=[];
for i from 1 to nops(L) do
if isccvar(L[i]) then c:=append(c,L[i]);
elif isacvar(L[i]) or isbcvar(L[i]) then b:=append(b,L[i]);
else a:=append(a,L[i]); end_if;
end_for;
[op(a),op(b),op(c)]
end_proc:


irredFactorList:=proc(a)
local f,i,r;
begin
r:=[];
f:=coerce(factor(a),DOM_LIST);
for i  from 2 to nops(f) do if i mod 2 =0 then r:=[op(r),f[i]]; end_if; end_for;
return(r);
end_proc:


FXsqrtReplCounter:=1: 
// Achtung: Neuimplementation direkt darunert!!!!!!!!!!!!
sqrtRepl:=proc(e,nn) /* eliminiert sqrt in e durch neue Variablen, die mit nn starten */  
local a,u,v,nv,ne,i,n,z;  /* Rckgabe ist [ersatz_fr_e, neuevars,neue_glg] */
begin
if atomicTypeQ(e) then [e,[],[]]  
elif type(e)="_power" then 
if domtype(op(e,2))=DOM_RAT then z:=numer(op(e,2)); n:=denom(op(e,2));
  FXsqrtReplCounter:=FXsqrtReplCounter+1;
  nv:=[text2expr(expr2text(nn).expr2text(FXsqrtReplCounter))];
  u:=sqrtRepl(op(e,1),nn);
  ne:=[nv[1]^n=u[1]^z,op(u[3])];
  nv:=[op(nv),op(u[2])];
  [nv[1],nv,ne]
else 
  u:=sqrtRepl(op(e,1),nn);v:=sqrtRepl(op(e,2),nn);
  [u[1]^v[1],[op(u[2]),op(v[2])],[op(u[3]),op(v[3])]]
end_if
else nv:=[]; ne:=[]; a:=[];
   for i from 1 to nops(e) do
      u:=sqrtRepl(op(e,i),nn); 
      nv:=[op(nv),op(u[2])];ne:=[op(ne),op(u[3])];a:=[op(a),u[1]];
   end_for; 
   if type(e)=DOM_LIST then [a,nv,ne]
   elif type(e)=DOM_SET then [{op(a)},nv,ne]
    else 
   [fp::apply(op(e,0),op(a)),nv,ne]
end_if   
end_if
end_proc:

// Achtung: neuimplemnt: 

sqrtRepl:=proc(ee,nn) /* eliminiert sqrt in e durch neue Variablen, die mit nn starten */  
local ersetzte, walk,a,u,v,nv,ne,i,n,z;  /* Rckgabe ist [ersatz_fr_e, neuevars,neue_glg] */
begin
nv:=[]; ne:=[]; ersetzte:=[]; // ersetze ist [[term,z,n,nv],...]
walk:=proc(e) begin /*print("walk",e,"nv=",nv,"ne=",ne);*/
if atomicTypeQ(e) then return(e); 
elif type(e)="_power" then 
if domtype(op(e,2))=DOM_RAT then z:=numer(op(e,2)); n:=denom(op(e,2));
  u:=walk(op(e,1)); 
  for i from 1 to nops(ersetzte) do
      if ersetzte[i][1]=u and ersetzte[i][2]=z and ersetzte[i][3]=n then return(ersetzte[i][4]) end_if;
  end_for; 
  for i from 1 to nops(ersetzte) do
      if ersetzte[i][1]=u and ersetzte[i][2]=-z and ersetzte[i][3]=n then return(1/ersetzte[i][4]) end_if;
  end_for; 
  FXsqrtReplCounter:=FXsqrtReplCounter+1;
  nv:=[op(nv), text2expr(expr2text(nn).expr2text(FXsqrtReplCounter))];
  ne:=[op(ne), nv[nops(nv)]^n=u^z];
ersetzte:=[op(ersetzte),[u,z,n,nv[nops(nv)]]];
return(nv[nops(nv)]);
else 
  u:=walk(op(e,1));v:=walk(op(e,2)); return(u^v);
end_if
else 
   if type(e)=DOM_LIST then return(map(e,walk))
   elif type(e)=DOM_SET then return(map(e,walk)) 
    else 
        a:=map([op(e)],walk); 
        return(fp::apply(op(e,0),op(a)))
end_if   
end_if
end_proc;
ee:=walk(ee);
[ee,nv,ne]
end_proc:


NoOc:=proc(term,var) // wie oft kommt var in term vor?
local s,i; begin 
if term=var then 1 
elif atomicTypeQ(term) then 0
elif domtype(term)=DOM_LIST then max(op(map(term,NoOc,var)))
else s:=0; for i from 1 to nops(term) do s:=s+NoOc(op(term,i),var); end_for; s
end_if
end_proc:


/*======================= Ende Minimale Realitionskurvenberechnung ===============================*/

/*--------------------- Stereographische Projektion --------------------------------*/

K2S:=proc(p)
local r,x,y,phi,theta,eps;
begin
eps:=1e-14;
x:=float(p[1]); y:=float(p[2]); r:=sqrt(x^2+y^2);
if abs(x)<eps and abs(y)<eps then return([0,0]); end_if;
theta:=arctan(r/1.0);
phi:=myarctan2(x,y);
[phi,theta]
end_proc:

S2K:=proc(p)
local r,x,y,phi,theta,eps;
begin
eps:=1e-14;
phi:=float(p[1]); theta:=float(p[2]); r:=tan(theta);
x:=r*cos(phi); y:=r*sin(phi);
[x,y]
end_proc:

myarctan2:=proc(x,y)
/* garantiert folgendes: x=cos(phi), y=sin(phi), dann myarctan2(x,y) liefert phi */
begin
if x>=0 and y>=0 then 
   if abs(x)>abs(y) then float(arctan(y/x)) else float(PI/2-arctan(x/y)) end_if
elif x<=0 and y<=0 then 
   if abs(x)>abs(y) then float(PI+arctan(y/x)) else float(PI+PI/2-arctan(x/y)) end_if
elif x<=0 and y>0 then 
   if abs(x)>abs(y) then float(PI+arctan(y/x)) else float(PI/2-arctan(x/y)) end_if
else
   if abs(x)>abs(y) then float(2*PI+arctan(y/x)) else float(PI+PI/2-arctan(x/y)) end_if
end_if;
end_proc:

/*--------------------- Ende Stereographische Projektion --------------------------------*/


// Sonstige Vereinfachungen 

travSimplSinCos:=proc(a)
save x;
begin
delete x;
if atomicTypeQ(a) then return(a); end_if;
if match(a,sin(x)^2+cos(x)^2)<>FAIL then return(1); end_if;
map(a,travSimplSinCos)
end_proc:


clearDenom:=proc(eq) // format a/b=c/d um in a*d=c*b 
local l,r,L,R;
begin
if type(eq)<>"_equal" and type(eq)<>"_less" and type(eq)<>"_leequal" then return(eq); end_if;
l:=inertFV(lhs(eq));r:=inertFV(rhs(eq));
L:=numer(l)*denom(r);R:=numer(r)*denom(l);
unInertFV(L=R)
end_proc:

clearDenom:=proc(eq) // format a=b um in numer(a-b)=0 
local a;
begin
if type(eq)<>"_equal" and type(eq)<>"_less" and type(eq)<>"_leequal" then return(eq); end_if;
a:=inertFV(lhs(eq)-rhs(eq));
unInertFV(numer(a)=0)
end_proc:


