// FeliX-Datei 
Config:=[xc["P1"] = -4.542253521, yc["P1"] = -0.2992957746, xc["P2"] = 3.802816901, yc["P2"] = 0.1232394366, xc["P3"] = 4.436619701, yc["P3"] = 5.510563401, ac["L4"] = -0.05056813253, bc["L4"] = 0.9987206136, cc["L4"] = -0.06921958292, ac["L5"] = -0.5432512801, bc["L5"] = 0.8395701559, cc["L5"] = 2.216305241, ac["L6"] = 0.9931506048, bc["L6"] = -0.1168412437, cc["L6"] = 3.762370458, ac["L7"] = 0.30738834, bc["L7"] = -0.9515841573, cc["L7"] = -1.111430652, ac["L8"] = 0.7302294116, bc["L8"] = 0.6832020246, cc["L8"] = 2.861126181, xc["P9"] = 2.169640175, yc["P9"] = 1.868833912, ac["L10"] = 0.8395701563, bc["L10"] = 0.5432512794, cc["L10"] = 2.836811554, xc["P11"] = 1.177691661, yc["P11"] = 3.401845246, xc["C12"] = 2.169640175, yc["C12"] = 1.868833911, rc["C12"] = 1.825947865];
Objects:=[["P1", "point"], ["P2", "point"], ["P3", "point"], ["L4", "line"], ["L5", "line"], ["L6", "line"], ["L7", "line"], ["L8", "line"], ["P9", "point"], ["L10", "line"], ["P11", "point"], ["C12", "circle"]];
BasicObjects:=["P1", "P2", "P3"];
Equations:=[ac["L4"]*xc["P1"] + bc["L4"]*yc["P1"] = cc["L4"], ac["L4"]*xc["P2"] + bc["L4"]*yc["P2"] = cc["L4"], ac["L5"]*xc["P1"] + bc["L5"]*yc["P1"] = cc["L5"], ac["L5"]*xc["P3"] + bc["L5"]*yc["P3"] = cc["L5"], ac["L6"]*xc["P3"] + bc["L6"]*yc["P3"] = cc["L6"], ac["L6"]*xc["P2"] + bc["L6"]*yc["P2"] = cc["L6"], ac["L4"]*bc["L5"]*cc["L7"] - ac["L4"]*bc["L7"]*cc["L5"] - ac["L5"]*bc["L4"]*cc["L7"] + ac["L5"]*bc["L7"]*cc["L4"] + ac["L7"]*bc["L4"]*cc["L5"] - ac["L7"]*bc["L5"]*cc["L4"] = 0, bc["L7"]*(1/2*(ac["L5"]^2 + bc["L5"]^2)^(1/2)*ac["L4"] + 1/2*(ac["L4"]^2 + bc["L4"]^2)^(1/2)*ac["L5"]) = ac["L7"]*(1/2*(ac["L5"]^2 + bc["L5"]^2)^(1/2)*bc["L4"] + 1/2*(ac["L4"]^2 + bc["L4"]^2)^(1/2)*bc["L5"]), ac["L4"]*bc["L6"]*cc["L8"] - ac["L4"]*bc["L8"]*cc["L6"] - ac["L6"]*bc["L4"]*cc["L8"] + ac["L6"]*bc["L8"]*cc["L4"] + ac["L8"]*bc["L4"]*cc["L6"] - ac["L8"]*bc["L6"]*cc["L4"] = 0, bc["L8"]*(1/2*(ac["L6"]^2 + bc["L6"]^2)^(1/2)*ac["L4"] + 1/2*(ac["L4"]^2 + bc["L4"]^2)^(1/2)*ac["L6"]) = ac["L8"]*(1/2*(ac["L6"]^2 + bc["L6"]^2)^(1/2)*bc["L4"] + 1/2*(ac["L4"]^2 + bc["L4"]^2)^(1/2)*bc["L6"]), ac["L8"]*xc["P9"] + bc["L8"]*yc["P9"] = cc["L8"], ac["L7"]*xc["P9"] + bc["L7"]*yc["P9"] = cc["L7"], ac["L10"]*ac["L5"] + bc["L10"]*bc["L5"] = 0, ac["L10"]*xc["P9"] + bc["L10"]*yc["P9"] = cc["L10"], ac["L5"]*xc["P11"] + bc["L5"]*yc["P11"] = cc["L5"], ac["L10"]*xc["P11"] + bc["L10"]*yc["P11"] = cc["L10"], rc["C12"]^2 = (xc["C12"] - xc["P11"])^2 + (yc["C12"] - yc["P11"])^2, xc["C12"] = xc["P9"], yc["C12"] = yc["P9"]];
FelixCurves:=[];
FXcomments:=[];
commentTable:=table(ac["L5"]*xc["P3"] + bc["L5"]*yc["P3"] = cc["L5"]="P3 auf L5",bc["L7"]*(1/2*(ac["L5"]^2 + bc["L5"]^2)^(1/2)*ac["L4"] + 1/2*(ac["L4"]^2 + bc["L4"]^2)^(1/2)*ac["L5"]) = ac["L7"]*(1/2*(ac["L5"]^2 + bc["L5"]^2)^(1/2)*bc["L4"] + 1/2*(ac["L4"]^2 + bc["L4"]^2)^(1/2)*bc["L5"])="",ac["L10"]*xc["P11"] + bc["L10"]*yc["P11"] = cc["L10"]="P11 auf L10",ac["L6"]*xc["P2"] + bc["L6"]*yc["P2"] = cc["L6"]="P2 auf L6",ac["L8"]*xc["P9"] + bc["L8"]*yc["P9"] = cc["L8"]="P9 auf L8",ac["L6"]*xc["P3"] + bc["L6"]*yc["P3"] = cc["L6"]="P3 auf L6",ac["L10"]*xc["P9"] + bc["L10"]*yc["P9"] = cc["L10"]="P9 auf L10",xc["C12"] = xc["P9"]="C12=K(P9,P11)",ac["L4"]*bc["L6"]*cc["L8"] - ac["L4"]*bc["L8"]*cc["L6"] - ac["L6"]*bc["L4"]*cc["L8"] + ac["L6"]*bc["L8"]*cc["L4"] + ac["L8"]*bc["L4"]*cc["L6"] - ac["L8"]*bc["L6"]*cc["L4"] = 0="WH: Kopunkt.",bc["L8"]*(1/2*(ac["L6"]^2 + bc["L6"]^2)^(1/2)*ac["L4"] + 1/2*(ac["L4"]^2 + bc["L4"]^2)^(1/2)*ac["L6"]) = ac["L8"]*(1/2*(ac["L6"]^2 + bc["L6"]^2)^(1/2)*bc["L4"] + 1/2*(ac["L4"]^2 + bc["L4"]^2)^(1/2)*bc["L6"])="",ac["L5"]*xc["P11"] + bc["L5"]*yc["P11"] = cc["L5"]="P11 auf L5",ac["L4"]*xc["P1"] + bc["L4"]*yc["P1"] = cc["L4"]="P1 auf L4",ac["L4"]*bc["L5"]*cc["L7"] - ac["L4"]*bc["L7"]*cc["L5"] - ac["L5"]*bc["L4"]*cc["L7"] + ac["L5"]*bc["L7"]*cc["L4"] + ac["L7"]*bc["L4"]*cc["L5"] - ac["L7"]*bc["L5"]*cc["L4"] = 0="WH: Kopunkt.",ac["L4"]*xc["P2"] + bc["L4"]*yc["P2"] = cc["L4"]="P2 auf L4",rc["C12"]^2 = (xc["C12"] - xc["P11"])^2 + (yc["C12"] - yc["P11"])^2="P11 auf C12",ac["L5"]*xc["P1"] + bc["L5"]*yc["P1"] = cc["L5"]="P1 auf L5",yc["C12"] = yc["P9"]="C12=K(P9,P11)",ac["L10"]*ac["L5"] + bc["L10"]*bc["L5"] = 0="L10 ortho L5",ac["L7"]*xc["P9"] + bc["L7"]*yc["P9"] = cc["L7"]="P9 auf L7");
FXConOpt:=[];
FXCanvasOpt:=[];
NameCounter:=13;
FXuseLP:=TRUE;
FXuseSPH:=FALSE;
FXRandomR:=0.0;
VisualProps:="C12:TRUE:TRUE:255,0,0,255;L10:TRUE:TRUE:255,255,51,255;L4:TRUE:TRUE:255,0,0,255;L5:TRUE:TRUE:255,0,0,255;L6:TRUE:TRUE:255,0,0,255;L7:TRUE:TRUE:102,255,51,255;L8:TRUE:TRUE:102,255,51,255;P1:TRUE:TRUE:255,0,0,255;P11:TRUE:TRUE:255,0,0,255;P2:TRUE:TRUE:255,0,0,255;P3:TRUE:TRUE:255,0,0,255;P9:TRUE:TRUE:255,0,0,255";

