// FeliX-Datei 
Config:=[xc["B"] = -4.891304348, yc["B"] = 0.0, xc["Q"] = -1.270297121, yc["Q"] = -1.948042232e-25, xc["M"] = 1.031354941, yc["M"] = 4.545572073e-26, xc["C4"] = -1.270297121, yc["C4"] = -1.948042232e-25, rc["C4"] = 3.621007226, xc["C5"] = 1.031354941, yc["C5"] = 4.545572073e-26, rc["C5"] = 5.922659289, xc["EE"] = 2.350710105, yc["EE"] = 2.068482459e-42, xc["L"] = 6.95401423, yc["L"] = 5.043243834e-48, xc["P8"] = 4.652362168, yc["P8"] = 1.034243751e-42, xc["P9"] = 4.652362168, yc["P9"] = 4.686811252, ac["m"] = 1.0, bc["m"] = -1.608956024e-16, cc["m"] = 4.652362168, ac["L11"] = 0.4408049508, bc["L11"] = -0.8976029163, cc["L11"] = -2.156111172, xc["P"] = 0.9435214853, yc["P"] = 2.865431994];
Objects:=[["B", "point"], ["Q", "point"], ["M", "point"], ["C4", "circle"], ["C5", "circle"], ["EE", "point"], ["L", "point"], ["P8", "point"], ["P9", "point"], ["m", "line"], ["L11", "line"], ["P", "point"]];
BasicObjects:=["B", "L"];
Equations:=[yc["B"] = 0, yc["Q"] = 0, yc["M"] = 0, rc["C4"]^2 = (xc["B"] - xc["C4"])^2 + (yc["B"] - yc["C4"])^2, xc["C4"] = xc["Q"], yc["C4"] = yc["Q"], rc["C5"]^2 = (xc["B"] - xc["C5"])^2 + (yc["B"] - yc["C5"])^2, xc["C5"] = xc["M"], yc["C5"] = yc["M"], rc["C4"]^2 = (xc["C4"] - xc["EE"])^2 + (yc["C4"] - yc["EE"])^2, rc["C5"]^2 = (xc["C5"] - xc["L"])^2 + (yc["C5"] - yc["L"])^2, 0 = yc["EE"], 0 = yc["L"], rc["C5"]^2 = (xc["C5"] - xc["P9"])^2 + (yc["C5"] - yc["P9"])^2, xc["P9"]*ac["m"] + yc["P9"]*bc["m"] = cc["m"], xc["P8"]*ac["m"] + yc["P8"]*bc["m"] = cc["m"], 0 = bc["m"], ac["L11"]*xc["P9"] + bc["L11"]*yc["P9"] = cc["L11"], ac["L11"]*xc["B"] + bc["L11"]*yc["B"] = cc["L11"], rc["C4"]^2 = (xc["C4"] - xc["P"])^2 + (yc["C4"] - yc["P"])^2, ac["L11"]*xc["P"] + bc["L11"]*yc["P"] = cc["L11"], 2*xc["P8"] = xc["EE"] + xc["L"], 2*yc["P8"] = yc["EE"] + yc["L"]];
FelixCurves:=[];
FXcomments:=[];
commentTable:=table((ac["L11"]*xc["P9"] + bc["L11"]*yc["P9"] = cc["L11"])="P9 auf L11",(yc["C5"] = yc["M"])="C5=K(M,B)",(rc["C4"]^2 = (xc["C4"] - xc["EE"])^2 + (yc["C4"] - yc["EE"])^2)="EE auf C4",(xc["P9"]*ac["m"] + yc["P9"]*bc["m"] = cc["m"])="P9 auf m",(ac["L11"]*xc["B"] + bc["L11"]*yc["B"] = cc["L11"])="B auf L11",(rc["C5"]^2 = (xc["C5"] - xc["L"])^2 + (yc["C5"] - yc["L"])^2)="L auf C5",(yc["C4"] = yc["Q"])="C4=K(Q,B)",(rc["C5"]^2 = (xc["C5"] - xc["P9"])^2 + (yc["C5"] - yc["P9"])^2)="P9 auf C5",(rc["C4"]^2 = (xc["B"] - xc["C4"])^2 + (yc["B"] - yc["C4"])^2)="B auf C4",(2*xc["P8"] = xc["L"] + xc["M"])="x P8=MP(M,L)",(xc["C5"] = xc["M"])="C5=K(M,B)",(ac["L11"]*xc["P"] + bc["L11"]*yc["P"] = cc["L11"])="P auf L11",(rc["C5"]^2 = (xc["B"] - xc["C5"])^2 + (yc["B"] - yc["C5"])^2)="B auf C5",(xc["P8"]*ac["m"] + yc["P8"]*bc["m"] = cc["m"])="P8 auf m",(2*yc["P8"] = yc["L"] + yc["M"])="y P8=MP(M,L)",(xc["C4"] = xc["Q"])="C4=K(Q,B)",(rc["C4"]^2 = (xc["C4"] - xc["P"])^2 + (yc["C4"] - yc["P"])^2)="P auf C4");
FXConOpt:=[];
FXCanvasOpt:=[];
NameCounter:=14;
FXuseLP:=TRUE;
FXuseSPH:=FALSE;
FXRandomR:=0.0;
FXText:="";
VisualProps:="B:TRUE:TRUE:255,0,0,255;C4:TRUE:TRUE:255,0,0,255;C5:TRUE:TRUE:255,0,0,255;EE:TRUE:TRUE:255,0,0,255;L:TRUE:TRUE:255,0,0,255;L11:TRUE:TRUE:255,0,0,255;M:TRUE:TRUE:255,0,0,255;P:TRUE:TRUE:0,255,0,255;P8:TRUE:TRUE:255,0,0,255;P9:TRUE:TRUE:255,0,0,255;Q:TRUE:TRUE:255,0,0,255;m:TRUE:TRUE:255,0,0,255";

