// FeliX-Datei 
Config:=[xc["P1"] = -4.420289855, yc["P1"] = -1.032608696, xc["P2"] = 1.34057971, yc["P2"] = -1.105072464, ac["L3"] = 0.01257762135, bc["L3"] = 0.9999208986, cc["L3"] = -1.088123747, xc["P4"] = -2.68115942, yc["P4"] = 3.351449275, xc["P5"] = -1.014492754, yc["P5"] = 5.380434783, xc["C6"] = -2.68115942, yc["C6"] = 3.351449275, rc["C6"] = 2.62574941, xc["P7"] = -2.829549142, yc["P7"] = 5.973002338, xc["S8"] = -2.829549142, yc["S8"] = 5.973002338, vx["S8"] = 4.170128852, vy["S8"] = -7.078074802, ac["L10"] = -0.9999208986, bc["L10"] = 0.01257762135, cc["L10"] = 2.904451482, ac["L11"] = -0.5076128407, bc["L11"] = 0.8615852854, cc["L11"] = 1.354115432, xc["P12"] = -2.906451225, yc["P12"] = -0.1407133254];
Objects:=[["P1", "point"], ["P2", "point"], ["L3", "line"], ["P4", "point"], ["P5", "point"], ["C6", "circle"], ["P7", "point"], ["S8", "vector"], ["L10", "line"], ["L11", "line"], ["P12", "point"]];
BasicObjects:=["P1", "P2", "P4", "P5"];
Equations:=[ac["L3"]*xc["P1"] + bc["L3"]*yc["P1"] = cc["L3"], ac["L3"]*xc["P2"] + bc["L3"]*yc["P2"] = cc["L3"], rc["C6"]^2 = (xc["C6"] - xc["P5"])^2 + (yc["C6"] - yc["P5"])^2, xc["C6"] = xc["P4"], yc["C6"] = yc["P4"], rc["C6"]^2 = (xc["C6"] - xc["P7"])^2 + (yc["C6"] - yc["P7"])^2, xc["S8"] = xc["P7"], yc["S8"] = yc["P7"], vx["S8"] = xc["P2"] - xc["P7"], vy["S8"] = yc["P2"] - yc["P7"], ac["L10"]*ac["L3"] + bc["L10"]*bc["L3"] = 0, ac["L10"]*xc["P7"] + bc["L10"]*yc["P7"] = cc["L10"], bc["L11"]*vx["S8"] - ac["L11"]*vy["S8"] = 0, ac["L11"]*xc["P1"] + bc["L11"]*yc["P1"] = cc["L11"], ac["L11"]*xc["P12"] + bc["L11"]*yc["P12"] = cc["L11"], ac["L10"]*xc["P12"] + bc["L10"]*yc["P12"] = cc["L10"]];
FelixCurves:=[];
FXcomments:=FXcomments;
commentTable:=table(ac["L10"]*xc["P12"] + bc["L10"]*yc["P12"] = cc["L10"]="P12 auf L10",ac["L11"]*xc["P12"] + bc["L11"]*yc["P12"] = cc["L11"]="P12 auf L11",ac["L11"]*xc["P1"] + bc["L11"]*yc["P1"] = cc["L11"]="P1 auf L11",bc["L11"]*vx["S8"] - ac["L11"]*vy["S8"] = 0="L11 ortho S8",ac["L10"]*xc["P7"] + bc["L10"]*yc["P7"] = cc["L10"]="P7 auf L10",ac["L10"]*ac["L3"] + bc["L10"]*bc["L3"] = 0="L10 ortho L3",vy["S8"] = yc["P2"] - yc["P7"]="y Ende S8 = P2",vx["S8"] = xc["P2"] - xc["P7"]="x Ende S8 = P2",yc["S8"] = yc["P7"]="y Anfang S8 = P7",xc["S8"] = xc["P7"]="x Anfang S8 = P7",rc["C6"]^2 = (xc["C6"] - xc["P7"])^2 + (yc["C6"] - yc["P7"])^2="P7 auf C6",yc["C6"] = yc["P4"]="C6=K(P4,P5)",xc["C6"] = xc["P4"]="C6=K(P4,P5)",rc["C6"]^2 = (xc["C6"] - xc["P5"])^2 + (yc["C6"] - yc["P5"])^2="P5 auf C6",ac["L3"]*xc["P2"] + bc["L3"]*yc["P2"] = cc["L3"]="P2 auf L3",ac["L3"]*xc["P1"] + bc["L3"]*yc["P1"] = cc["L3"]="P1 auf L3");
FXConOpt:=[];
FXCanvasOpt:=[];
NameCounter:=12;
FXuseLP:=TRUE;
FXuseSPH:=FALSE;
FXRandomR:=0.0;
FXText:="";
VisualProps:="C6:TRUE:TRUE:255,0,0,255;L10:TRUE:TRUE:255,255,0,255;L11:TRUE:TRUE:255,255,0,255;L3:TRUE:TRUE:255,0,0,255;P1:TRUE:TRUE:255,0,0,255;P12:TRUE:TRUE:102,255,0,255;P2:TRUE:TRUE:255,0,0,255;P4:TRUE:TRUE:255,0,0,255;P5:TRUE:TRUE:255,0,0,255;P7:TRUE:TRUE:255,0,0,255;S8:TRUE:TRUE:255,0,0,255";

